<%@ page language="java" %>
<% String VERSION_LM = "04-29-2013";
String rzmodule = ""; %>
<%@ include file="/util/setup_editform_header.jsp" %>
<%@ page import="revize.db.LinkManager, revize.publish.PublishingUtils" %>
<%
/* * * * * * * * * * * * * * * LINK MANAGER PROCESSING * * * * * * * * * * * * * *

===============
Input Arguments
===============
	Some arguments are passed on the url; others are passed as link properties
	of the the RZ.link.<linkname> object of the window opener (as of build 82).
	See RZsetLinkManagerProperties() in snippet_helper.js for details.

==========
HTML Forms
==========
	3 forms are required to properly hide the filename input field on Netscape.

	The XMLForm is always the first form and contains the linkmanager fields.

	The filenameForm is next and only defined if at least one of the specified
	templates permits user specified filenames.  It is hidden unless the
	selected template permits user specified filenames (If the window is resized
	in Netscape, the form must always be displayed because older versions of
	Netscape lose layer properties after resizing).

	The controlForm is last and always defined.  It contains the continue and
	cancel buttons as well as additional working fields.  Link properties are
	initially stored there in case the calling window is closed or refreshed.

---------------------------------------------------------------------------*/
String validfilecharacters = "~!@#$%()+-";	//DCO 07-05-2009
String defaultFileExt = System.getProperty(RevizeProperties.PUBLISHER_DEFAULT_FILE_EXTENSION);
String linkoptions = "," + StringUtils.getParameter(request,"linkoptions") + ",";
String linkname = StringUtils.getParameter(request,"linkname");
String listModule = StringUtils.getParameter(request,"module");
String urlModule = StringUtils.getParameter(request,"urlmodule");
String linkType = StringUtils.getParameter(request,"linktype");
String recordId = StringUtils.getParameter(request,"recordid");
String urlRecord = StringUtils.getParameter(request,"urlrecord");
String templateLabel = StringUtils.getParameter(request,"templatename");
String linkfilename = "";
String href = java.net.URLDecoder.decode(StringUtils.getParameter(request,"href"));
if( !rz.isvalidmodule(listModule) )
{
	linkoptions = ",url,";
	listModule = "";
}
if( linkoptions.indexOf(",template,") > 0 && listModule.length() == 0)
	linkoptions = StringUtils.replaceAll(linkoptions,",template,", ",");
boolean isRTE = StringUtils.getParameterBoolean(request,"rte");
boolean isTinyMCE = StringUtils.getParameter(request,"rte").equals("tinymce");
boolean isExistingTemplate = false;

//----- Get List Module and Link field names - were specified as url parameters
//		but now are now hard coded names.
String linkIdField = "linkid";
String linkTypeField = "linktype";
String linkFileField = "linkfile";
String linkImageField = "linkimage";
String linkPageField = "linkpage";
String linkDisplayField = "linkdisplay";
String linkSeqField = "linkseq";
String appendOther="";
if (linkoptions.indexOf(",noseq,") != -1) linkSeqField = "";	//seq number suppressed

String linkId = rz.fetch( listModule, linkIdField, "raw" );
if (rz.editaction.equals("create")) linkId = "-1";

if(!isRTE)
	linkType = rz.fetch( listModule, linkTypeField, "raw" );

String linkPageRaw = rz.fetch( listModule, linkPageField, "raw" );
String linkPage = StringUtils.convertStringForSource(linkPageRaw);

// If it's a url link and a revize managed page
if(linkType.equals("urltemplate"))
{
	String linkurl = rz.gettemplateinstanceurl(linkPageRaw,"",new Integer(linkId).intValue());
	// Aray started

	if (rz.fieldtype( listModule, "other" ) != -1)
	{
		appendOther = rz.fetch( listModule, "other", "" ).trim();
		linkurl = linkurl + appendOther;
	}
	// Aray finished
	linkPage = StringUtils.convertStringForSource(linkurl);
	linkType = "url";
}
else if(linkType.equals("url") && !urlModule.equals(""))
{
	String linkurl = rz.gettemplateinstanceurl(templateLabel,urlModule,new Integer(urlRecord).intValue());
	linkPage = StringUtils.convertStringForSource(linkurl);
}
else if(isRTE && linkType.equals("url"))
{
	linkPage = StringUtils.convertStringForSource(href);
}

//----- if existing template link, no other link type choices are displayed
else if(linkType.equals("template"))
{
	isExistingTemplate = true;
	linkoptions = ",template,";
}

// link reference file retrieved in XMLform field
String linkDisplay = rz.fetch( listModule, linkDisplayField, "raw" );
linkDisplay = StringUtils.convertStringForSource(linkDisplay);
String linkFilename = rz.fetch( listModule, "linkfilename", "raw" );
String linkRTE = rz.fetch( listModule, "linkrte", "raw" );
if (linkRTE.indexOf("Unknown Field") != -1) linkRTE="";

String linkStatus = "";
//TODO: linkStatus is new field needed for future rollback when RTE is canceled
//linkStatus = rz.fetch( listModule, "linkstatus", "raw" );
String linkLevel = rz.fetch( listModule, "linklevel", "raw" );
String linkParent = rz.fetch( listModule, "linkparent", "raw" );
String linkParentId = rz.fetch( listModule, "linkparentid", "raw" );
String linkTarget = rz.fetch( listModule, "linktarget", "raw" );

String linkSortKey = "";	//original value used to populate form field
if (rz.isvalidfield(listModule,"linksortkey"))
{
	rz.fetch( listModule, "linksortkey", "raw" ).trim();
	if (!rz.nodata) linkSortKey = rz.content;
}

String linkSectionId = "";
String linkToSectionId = "0";
String sectionFolder = "";
if (rz.isvalidfield(listModule,"linksectionid"))
{
	linkSectionId = rz.fetch(listModule,"linksectionid","raw,report");

	if (rz.isvalidfield(listModule,"linktosectionid"))
	{
		linkToSectionId = rz.fetch(listModule,"linktosectionid","raw,report");

		if (rz.editaction.equals("update")
		&& linkType.equals("template")
		&& !linkLevel.equals("0")
		&& !linkSectionId.equals("0")
		&& linkToSectionId.equals("0"))
			rz.setTrace( "Warning: linktosectionid should not be zero\n"
			           + "         unless linksectionid is not zero.\n"
			           + "Contact your Revize Administrator.");
	}

	//----- Get sections folder if field defined
	if (rz.isvalidfield("sections","folder"))
	{
		rz.fetch("sections","folder","raw,report","sections.sectionid="+linkSectionId);
		if (rz.nodata)
			rz.setTrace("No section properties found (sectionid="+linkSectionId+").");
		else
			sectionFolder = rz.content.trim();
	}
}

//----- Get the parent as defined in the webspace_permissions_table
String repair_page_key = "";
String repair_parent_key = "";
if (rz.editaction.equals("update")
&& rz.permissions_module.length() > 0
&& !linkPage.equals(""))
{
	repair_page_key = linkPageRaw + "[" + linkId + "]";
	String repair_where = rz.permissions_module+".page_key=" + repair_page_key;
	rz.fetch(rz.permissions_module,"parent_key","raw",repair_where);
	if (!rz.nodata) repair_parent_key = rz.content;

	// For urltemplate, breadcrumb parent is the real template's linkparent
	if (linkType.indexOf("urltemplate") == 0)
	{
		String repair_options = "raw,report,recordid=" + linkId;
		repair_parent_key = rz.fetch(rz.pagemodule,"linkparent",repair_options);
	}
}

//----- Get list of live channels					//04-29-2013

List channels = rz.getDataStore().readChannels();
Channel liveChannel = PublishingUtils.getLiveChannel(channels);
String liveChannelUrl = liveChannel.getBaseUrl();
String revizeChannelUrl = PublishingUtils.getRevizeChannel(channels).getBaseUrl();

//----- Get list of templates
rz.string = StringUtils.getParameter(request,"linktemplate");
String [] linkTemplates = StringUtils.split(rz.string,",");
for (int i=0; i<linkTemplates.length; i++) linkTemplates[i] = linkTemplates[i].trim();
String [] linkTemplatesFound = new String[ linkTemplates.length ];
for (int i=0; i<linkTemplates.length; i++) linkTemplatesFound[i] = "";

//----- Get specific custom template edit forms & module link fields
//		(TODO: custom edit forms & link fields are probably not implemented)
rz.string = StringUtils.getParameter(request,"linkeditform");
String [] linkEditForms = StringUtils.split(rz.string,",");
rz.string = StringUtils.getParameter(request,"linkmodulelink");	//back link from dep module..
String [] moduleLinkField = StringUtils.split(rz.string,",");	//..to link module

//----- File and Image related properties
String linkfilelocation = StringUtils.getParameter(request,"linkfilelocation");
if(linkfilelocation == null || linkfilelocation.equals(""))
linkfilelocation = StringUtils.getParameter(request,"filelocation");
//System.out.println("linkfilelocation = " + linkfilelocation);

rz.string = StringUtils.getParameter(request,"linkfileextensions");
String linkfileextensions = StringUtils.replaceAll(rz.string,",","|");

String linkimagelocation = StringUtils.getParameter(request,"imagelocation");
rz.string = StringUtils.getParameter(request,"linkimageextensions");
String linkimageextensions = StringUtils.replaceAll(rz.string,",","|");

//----- Get full list of authorized templates from server
//		then extract module and description for display
List templates = (List)revize_store.readTemplates();
SortedSet sortedResources = new TreeSet( templates );
Iterator itrTemplates = sortedResources.iterator();
boolean usePathFilename = false;
boolean useTarget = false;
boolean useTemplateThumbnails = false;

//----- Define vectors for templates added to drop down selection
Vector templateName = new Vector();
Vector templateDesc = new Vector();
Vector templateModule = new Vector();
Vector templateExtension = new Vector();
Vector templateEditForm = new Vector();
Vector templateModuleLinkField = new Vector();
Vector templateFilenameField = new Vector();
Vector templateImageList = new Vector();

//----- If templates are permitted
if (linkoptions.indexOf(",template,") != -1)
{
	//----- For all templates
	int opt = -1;
	while ( itrTemplates.hasNext() )
	{
		opt++;
		Template t = (Template)itrTemplates.next();
		String templateType = null;
		String dependentModule="";
		String dependentExtension=t.getFileNameExtension();
		String description = t.getDescription();
		if ( t.isUnique() )
			templateType = "uniquetemplate";
		else
		{
			templateType = "dependenttemplate";
			dependentModule=((DependentTemplate)t).getModuleLabel();
		}

		//----- Determine if this template is allowed
		boolean isTemplateSelected = false;

		if (linkTemplates.length == 0)		//if no templates specified
		{
			if (dependentModule.equals(listModule)) isTemplateSelected = true;
		}
		else
		{
			for ( int i=0; i<linkTemplates.length; i++ )
			{
				if ( t.getLabel().equalsIgnoreCase(linkTemplates[i]) )
				{
					isTemplateSelected = true;
					linkTemplatesFound[i] = "*";
					break;
				}
			}
		}
		//----- Save template properties if allowed
		int i = -1;
		if (isTemplateSelected && description.indexOf("NA:link") == -1)
		{
			i++;
			templateName.add( t.getLabel() );
			templateDesc.add( StringUtils.convertStringForSource(description) );
			templateModule.add( dependentModule );
			templateExtension.add( dependentExtension );

			if (linkEditForms.length < opt+1)
				templateEditForm.add( "" );
			else
				templateEditForm.add( linkEditForms[opt] );

			if (moduleLinkField.length < opt+1)
				templateModuleLinkField.add( "" );
			else
				templateModuleLinkField.add( moduleLinkField[opt] );

			// If template specifies field for the path/filename, save the fieldname.
			// TODO:for now only allow path/filename if template uses the link module
			String filenameField = "";
			if ( templateType.equals("dependenttemplate")
			&& ((DependentTemplate)t).getUseFilenameField())
				filenameField = ((DependentTemplate)t).getFilenameField();
			templateFilenameField.add( filenameField );

			String templateImgFile =  t.getLabel();
			templateImageList.add(templateImgFile);

			if (!filenameField.equals("")) usePathFilename = true;
		}
	}

	//Supported template image file formats
	String[] imageExt = {".jpg",".gif",".png"};
	//check if all the thumbnails images do exist for all the templates
	for(int index=0; index < templateImageList.size(); index++) {
		//set the flag to true for now. set to false if any image file is missing/not available
		useTemplateThumbnails = true;
		//check if this image exits as .jpg or .gif or .png
		String templateImage = null;
		java.net.URL tempUrl= null;
		for(int k=0; k < imageExt.length; k++){
			templateImage = "/"+rz.webspace + "/thumbnails/templates/" + (String)templateImageList.get(index)+imageExt[k];
			tempUrl= getServletContext().getResource(templateImage);
			if(tempUrl != null) {
				break;
			}
		}
		//System.out.println(index +"="+templateImage);
		if(tempUrl!=null){
			templateImage = request.getContextPath()+templateImage;
			templateImageList.set(index,templateImage);
		} else {
			useTemplateThumbnails = false;
			break;
		}

	}
}

%>

<!DOCTYPE html>
<!--[if lt IE 7 ]><html class="ie ie6" lang="en"> <![endif]-->
<!--[if IE 7 ]><html class="ie ie7" lang="en"> <![endif]-->
<!--[if IE 8 ]><html class="ie ie8" lang="en"> <![endif]-->
<!--[if (gte IE 9)|!(IE)]><!--><html lang="en"> <!--<![endif]-->
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
<%-- #RevizeProperties USE REVIZE MENU (DOCUMENT PROPERTIES) TO EDIT DATA BELOW:
status=
options=
server=localhost:8080
projectName=jamesisland
label=index
location=linkmanager_select.jsp
version=
docType=edit
subType=list
moduleName=
fieldName=
channels=|
description=
--%>
<head>
<title>Revize Link Manager Select</title>

<meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=0, minimum-scale=1.0, maximum-scale=1.0">

<link href="/revize/util/ui/css/font-awesome.min.css" rel="stylesheet">
<link href="/revize/util/ui/css/revize-ui.css" rel="stylesheet">
<link href="/revize/util/ui/css/bootstrap-select.css" rel="stylesheet">
<link rel="shortcut icon" href="/revize/util/ui/img/favicon.ico">

<!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
<!--[if lt IE 9]>
	<script src="http://html5shim.googlecode.com/svn/trunk/html5.js"></script>
  <script src="/revize/util/ui/js/respond.min.js"></script>
<![endif]-->

<!--[if IE 7]>
	<link rel="stylesheet" href="/revize/util/ui/css/font-awesome-ie7.css">
<![endif]-->

 <%--
/********************************************/
/* RZhidden class hides elements in browser */
/* BUT allows DW to show in design view     */
/* Following css does not get published     */
/* DW uses these in design view             */
/********************************************/
--%>
<% if (false){ %>
<style type=text/css>
.RZhidden, .RZhidden * {
	display:block !IMPORTANT;
	background-color:#D5D5D5;
}
a.RZhidden, .RZhidden a
span.RZhidden, .RZhidden span {
	display:inline !IMPORTANT;
}
/* comment next line to show hidden divs */
.RZhidden {display:none !IMPORTANT}
</style>
<% } %>
<%--
/********************************************/
/* Following published for Browser display  */
/********************************************/
--%>
<style type=text/css>
.RZhidden {
display:none
}

body {
background:#fff;
padding:10px 20px!important;
font-size:14px;
}
/* label, input, button, select, textarea{font-size:14px;} */
a.nolink {
text-decoration:none;
color:#000
}

a.invisible {
color:#fff!important;
text-decoration:none
}

.left {
float:left
}

.right {
float:right
}

.center {
text-align:center
}

.clear {
clear:both
}

.fullwidth {
width:100%
}

.notable {
color:red
}

.boxed {
border:solid 1px #666
}

#linkdisplay {
position:relative
}

#linkdisplayImage {
display:none;
margin:0;
padding:0!important;
display:block;
height:auto;
overflow:hidden;
float:left;
padding:3px!important;
overflow:hidden
}

#linkdisplayImage img {
max-width:100%;
height:auto;
margin:0!important;
display:block;
float:left;
padding:4px!important;
background-color:#fff;
border:1px solid #ecf0f1;
border:1px solid rgba(0,0,0,0.2);
-webkit-box-shadow:0 1px 3px rgba(0,0,0,0.1);
-moz-box-shadow:0 1px 3px rgba(0,0,0,0.1);
box-shadow:0 1px 3px rgba(0,0,0,0.1)
}

#linkdisplay .imageLink,#linkdisplay.imageLink span,#linkdisplay.imageLink input {
display:none
}

#linkdisplay.imageLink .imageLink {
display:block
}
/*

css overrides to avoid vertical scroll -- even for 800 x 600 resolution
body {
	padding-top: 10px !important;
	padding-bottom: 10px !important;
}
h4.page-header, .control-group {
	margin-top: 10px !IMPORTANT;
	margin-bottom: 20px !IMPORTANT;
}
h4 {
	margin-bottom: 5px !IMPORTANT;
	padding-bottom: 5px !IMPORTANT;
}
form {
	margin-bottom: 0px !IMPORTANT;
}
pre.stackTrace {
	padding-top: 0px;
	padding-bottom: 0px;
	margin-bottom: 0px;
}
/* override BELOW css to avoid huge horizontal scroll for all resolutions */
/* suggestion: let's use wider screen and show to right rather than below */
/* div.selectAreaImg {width: 100% !IMPORTANT;} */
h1{font-size:24px;margin:0 0 20px}
small,.small{line-height:1.2;font-size:13px}
.checkbox-container{display:inline-block;position:relative;margin-left:5px;padding-left:25px;margin-bottom:23px;cursor:pointer;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;vertical-align:middle}
.checkbox-container input{position:absolute;opacity:0;cursor:pointer;height:0;width:0}
.checkmark{position:absolute;top:0;left:0;height:20px;width:20px;border:1px solid #98a0ac;border-radius:2px}
.checkbox-container:hover input ~ .checkmark{background-color:#f1f4f8}
.checkbox-container input:checked ~ .checkmark{background-color:#0024ff;border-color:#0024ff}
.checkmark:after{content:"";position:absolute;display:none}
.checkbox-container input:checked ~ .checkmark:after{display:block}
.checkbox-container .checkmark:after{left:6px;top:2px;width:4px;height:10px;border:solid #fff;border-width:0 2px 2px 0;-webkit-transform:rotate(45deg);-ms-transform:rotate(45deg);transform:rotate(45deg)}
.radio-container{display:inline-block;position:relative;margin-left:5px;padding-left:25px;margin-bottom:15px;cursor:pointer;font-size:18px;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}
.radio-container input{position:absolute;opacity:0;cursor:pointer}
.radio-container .checkmark{position:absolute;top:0;left:0;height:20px;width:20px;background-color:#fff;border-radius:50%}
.radio-container:hover input ~ .checkmark{background-color:#f1f4f8}
.radio-container input:checked ~ .checkmark{background-color:#0024ff;border-color:#0024ff}
.radio-container .checkmark:after{content:"";position:absolute;display:none}
.radio-container input:checked ~ .checkmark:after{display:block}
.radio-container .checkmark:after{top:5px;left:5px;width:8px;height:8px;border-radius:1111px;background:#fff}
.btn.btn-default{border:1px solid #e0e5ec!important}
p.page-header{margin-top:15px;font-weight:600;margin-bottom:10px;padding-bottom:15px;}
.form-horizontal .control-label{padding-top:20px}
.form-horizontal .controls{padding-top:10px}
.input-block{width:100%}
.input-block-with-btn{width:calc(100% - 100px)}
div.selectAreaImg {float: left; padding: 1px; width: 1000px}
div.selectAreaImg img { border: 2px solid white}
.selectedImg {border-width:2;width: 500px; height: 400px}
.help-block{margin-top:5px!important}
</style>


<%
int thumnbsCssWidth = 66*4;
if(templateImageList.size() >=4){
	thumnbsCssWidth = 66*templateImageList.size();
}
%>

<script type="text/javascript" src="https://ajax.googleapis.com/ajax/libs/jquery/1.4.2/jquery.min.js"></script>

<script type="text/javascript">
$(document).ready( function () {
	$('#RZtemplate').change(function() {
		templateChange();
		<%
		if(useTemplateThumbnails) {
		%>
  		/* setting currently changed option value to option variable */
		var templateId = $(this).find('option:selected').val();
		setTemplateImage(templateId);
		<%
		}
		%>
	});

		$("[type='checkbox']").wrap("<label class='checkbox-container'></label>");
		$(".checkbox-container").append("<span class='checkmark'></span>");
		$("[type='radio']").wrap("<label class='radio-container'></label>");
		$(".radio-container").append("<span class='checkmark'></span>");

});

function setTemplateImage(templateId){
	if(!isNaN(templateId)) {
		var selectedimghtml='<div><img src="'+templateImagePaths[templateId]+'" class="selectedImg" /><br/>'+templateNames[templateId]+'</div>';
		$('#selectedarea').empty().append($(selectedimghtml));
	} else {
		$('#selectedarea').empty();
	}
}

</script>

<%@ include file="/util/setup_editform_javascript.jsp" %>
<script type="text/javascript">
RZ.editformurl='' //TODO: disable for WF
// probably needed because custom code in tiny_mce_popup.js resets opener
if (RZ.savereturn == '')
{
	if (RZ.isMSIE && parent.dialogArguments)
		parent.opener = parent.dialogArguments;
	if (parent.RZ)
	{
		RZ.repair = parent.RZ.repair;
		RZ.auto = parent.RZ.auto;
	}
	if (typeof RZ.repair == 'undefined') RZ.repair = false;
	if (typeof RZ.auto == 'undefined') RZ.auto = false;
}
/*---------------------------------------------------------------------------
Global variables (should be part of global object not individual names)
----------------------------------------------------------------------------*/
var linkIdField, linkTypeField, linkFileField, linkPageField, linkDisplayField;

var origLinkDisplay, origLinkFile, origLinkId, origLinkType, origLinkPage,
    origLinkSeq, origLinkTarget, origLinkModule = '', origLinkFileFieldName,
    origLinkParent, origLinkNewSection;

var newLinkDisplay, newLinkId, newLinkType, newLinkPage, newLinkModule = '',
    newEditForm = '', newModuleLinkField = '', newLinkParent,
    newSection = false, linkfilename = '';

var templateDesc, templateModule, templateFilename, templateEditForm,
    templateModuleLinkField;

var RZuseFilename = false;
var isRTE = <%=isRTE%>;
var isTinyMCE = <%=isTinyMCE%>;
var other = '';
var linkname = "<%=linkname%>";
var linksectionid = "<%=linkSectionId%>";
var linktosectionid = "<%=linkToSectionId%>";

var linkplacement = RZgetoptionvalue(RZ.setparameter,'<%=listModule%>.linkplacement');
var linkparentid = parseInt(RZgetoptionvalue(RZ.setparameter,'<%=listModule%>.linkparentid'));
var linklevel = parseInt(RZgetoptionvalue(RZ.setparameter,'<%=listModule%>.linklevel'));

//if (isTinyMCE && RZ.savereturn == '')			//for RZisPopupCall
//	parent.RZ.editWindow = parent;
// 2/14/2020 Fix later

/*---------------------------------------------------------------------------
Setters
----------------------------------------------------------------------------*/
var RZlinkId = -1
var RZurl = ''
function RZsetLinkId(linkid)
{
	RZlinkId = linkid
}
function RZsetUrl(url)
{
	RZurl = url
}
/*---------------------------------------------------------------------------
page setup called by onload handler
----------------------------------------------------------------------------*/
function setup()
{
	if (RZ.savereturn != '') return;	//eliminate race if called after save

	//----- Resize window if it did not open in specified size (IE9)
	//linkwidth = window.parent.RZ.link['<%=linkname%>'].linkwidth;
	//linkheight = window.parent.RZ.link['<%=linkname%>'].linkheight;
	// 2/14/2020 Fix later
	if (!RZ.isIEstandards)
		RZresize(linkwidth.linkheight);

	// disable tinymce dialog style sheet; some page styles are still defined
	// as !important so page appearance does not flicker while loading
	for (var i=0;i<document.styleSheets.length;i++)
	{
		if (document.styleSheets[i].href
		&& document.styleSheets[i].href.indexOf('dialog') != -1)
			document.styleSheets[i].disabled = true;
	}

	// resize: spellcheck, image_manager could have been open with different size
	if (isTinyMCE && !RZ.isIEstandards)
		RZresize(RZgetLinkProperty('linkwidth'),RZgetLinkProperty('linkheight'),'',parent);

	//----- Following variables used by image/file manager
	RZ.linkDisplayField = document.XMLForm.RZtext	//field containing display text
	RZ.imagePathFilename = RZgetLinkProperty('linkfiledefault')	//IM input & output
<% if (linkoptions.indexOf(",file,") != -1){%>
	var fileInfo = RZgetfileinfo( RZ.imagePathFilename )
	var filename = fileInfo.filename + fileInfo.sep + fileInfo.extension
	if (filename != '')
		document.XMLForm.<%=linkFileField%>_display.value = filename
<%}%>

	//----- Initialize global variables used by link manager
	templateDesc = new Array()
	templateModule = new Array()
	templateExtension = new Array()
	templateEditForm = new Array()
	templateModuleLinkField = new Array()
	templateFilenameField = new Array()

	templateNames = new Array();
	templateImagePaths = new Array();

	//----- Get List Module and Link field names & original values
	listModule = '<%=listModule%>'
	linkIdField = '<%=linkIdField%>'
	linkTypeField = '<%=linkTypeField%>'
	linkPageField = '<%=linkPageField%>'
	linkDisplayField = '<%=linkDisplayField%>'

	origLinkId = '<%=linkId%>'
	origLinkType = '<%=linkType%>'
	origLinkPage = <%=linkPage%>
	origLinkDisplay = <%=linkDisplay%>
	origLinkParent = '<%=linkParent%>'
	if (document.linknewsectionForm)
		origLinkNewSection = RZgetFieldValue(document.linknewsectionForm.linknewsection);
	linkfilename= '<%=linkfilename%>'

	//----- Copy topnav list to leftnav list			//04-29-2013
	var topnav = document.getElementById("newsection-topnav-relatedlinks");
	var leftnav = document.getElementById("newsection-leftnav-relatedlinks");
	if (topnav && leftnav)
		leftnav.innerHTML = topnav.innerHTML;

	/* 04-29-2013
	//----- Determine if newsection permitted on existing links
	isSectionChangeAllowed = RZ.editaction == 'create' || RZ.repair || RZisadmin();

	// if DB fields or set values DO NOT exist...
	if (!<%=rz.isvalidfield(rz.pagemodule,"linktosectionid")%>	//field linktosectionid exists
	|| !<%=rz.isvalidfield(rz.pagemodule,"linkparentid")%>		//field linkparentid exists
	|| !RZ.setvalues.linkparentid)
		isSectionChangeAllowed = false;

	else if (!RZisadmin())
		isSectionChangeAllowed = false;

	//----- Activate new section selection if section change allowed
	if (isSectionChangeAllowed
	// below test disallows section change from new section to same section
	&& (linksectionid == linktosectionid || linktosectionid == "0"))
	{
		document.linknewsectionForm.linknewsection[0].disabled = false;
		document.linknewsectionForm.linknewsection[1].disabled = false;
		if (isRTE && linktosectionid == "0")	//default same section for RTE
			document.linknewsectionForm.linknewsection[0].checked = true;
	}
	*/

	//----- Set/update linkparent to input value if not blank
	//		Required for all link types because menu manager uses the first link
	//		at each level for all subsequent links at that level.
	if (RZwinaccess(RZ.parent.opener)
	&& typeof RZ.parent.opener.revize_migration != 'undefined')
		RZ.parent.RZ.link['<%=linkname%>'].linkparent = RZ.parent.RZ.parent_key
	newLinkParent = RZgetLinkProperty('linkparent')
	if (newLinkParent != '')
		RZsetfieldvalue( document.XMLForm.linkparent, newLinkParent )

<% if (linkoptions.indexOf(",file,") != -1){%>
	origLinkFile = document.XMLForm.linkfile.value
<%}%>
<% if (!linkSeqField.equals("") && rz.fieldtype(listModule,"linkseq") != -1){%>
	origLinkSeq = document.XMLForm.<%=linkSeqField%>.value
	if (origLinkSeq == '0.00' && RZ.editaction == 'create')
	{
		var linkseq = RZgetLinkProperty('linkseq');
		if (!linkseq) linkseq = '1.00';
		document.XMLForm.<%=linkSeqField%>.value = linkseq;
	}
<%}%>
	//----- Set linkdisplay and linktype
	var linkdisplay = RZgetLinkProperty('linkdisplay');
	if (linkdisplay == '') linkdisplay = <%=linkDisplay%>;
	/***********************************/
	/*BOOKMARK -----show image display*/
	/*********************************/
	else if (/^<img/i.test(linkdisplay))	//if img tag, display big thumbnail
	{										//only keep single ../ before /repository/...
		linkdisplay = linkdisplay.replace(/(repository\/)/, '$1');
		RZsetInnerHTML('linkdisplayImage', linkdisplay);
		document.getElementById('linkdisplay').className = 'imageLink';
		linkdisplay = '...IMAGE...';	//display text set in form field
	}
	RZsetfieldvalue( document.XMLForm.RZtext, linkdisplay )
	RZsetDefault( document.XMLForm.RZtext, 'linkdisplaydefault' )	//optional default value
	//RZsetDefault( document.XMLForm.RZtext, 'linkurldefault' )
	RZsetfieldvalue( document.XMLForm.RZlinkType, '<%=linkType%>' )
	if (isRTE) RZsetfieldvalue( document.XMLForm.linkrte, 'yes' )

	//----- Retrieve link properties for use later (in case opener window not accessible)
	RZsetDefault( document.controlForm.linkautocontinue, 'linkautocontinue' )
	RZsetDefault( document.controlForm.popupwidth, 'popupwidth' )
	RZsetDefault( document.controlForm.popupheight, 'popupheight' )
	RZsetDefault( document.controlForm.popupscroll, 'popupscroll' )
	RZsetDefault( document.controlForm.set, 'set' )
	RZsetDefault( document.controlForm.nexturl, 'nexturl' )
	RZsetDefault( document.controlForm.filelocation, 'filelocation' )

	var linkpathname = RZgetLinkProperty('linkpathname');
	if (linkpathname == '')
		linkpathname = '<%=sectionFolder%>'
	if (RZsubstring(linkpathname,0,1) == '/') linkpathname = linkpathname.substring(1);
	if (RZright(linkpathname,1) != '/') linkpathname += '/';
	if (linkpathname == '/') linkpathname = '';
	document.controlForm.linkpathname.value = linkpathname;

	RZsetDefault( document.controlForm.linknewsection, 'linknewsection' );
	if (RZgetfieldvalue(document.controlForm.linknewsection) == '*')
		RZsetfieldvalue(document.controlForm.linknewsection, '*all*');

	//----- Populate the bookmarks drop down (tinymce only)
	var linkbookmarks = RZgetLinkProperty('linkbookmarks');
	if (linkbookmarks && linkbookmarks.length)
	{
		for (i=0;i<linkbookmarks.length;i++)
			RZselectOptionAdd( document.XMLForm.RZcreateanchor,
			                   linkbookmarks[i], '#'+linkbookmarks[i], false)
	}
<%
if (linkoptions.indexOf(",template,") != -1)	//For template
{
	/* 04-29-2013
	//----- Determine if target permitted
	int linktargetType = rz.fieldtype(listModule,"linktarget");
	if (linktargetType != -1)
	{
		if (linktargetType != FieldDef.Type.TEXT)
		{
			%>
			//----- Display warning if linktarget field is wrong type
			RZalert( 'The "linktarget" field in the "' + listModule + '" module must be\n'
				   + 'defined as a text field to use the new page option.' )
			<%
		}
		else
		{
			useTarget = true;
		}
	}
	*/
	%>
	//----- Initialize template list
	RZclearList( document.XMLForm.RZtemplate )
	RZselectOptionAdd( document.XMLForm.RZtemplate, '-- Select Web Page --', '*NONE*', true)
	<%
	String templateDefault = "";
	if (linkType.equals("template")) templateDefault = linkPageRaw;

	//----- Populate template dropdown
	for ( int i=0; i<templateName.size(); i++ )
	{
		String template = (String)templateName.get(i);
		%>
		RZselectOptionAdd( document.XMLForm.RZtemplate,
						   '<%=template%>', '<%=i%>',
						   ('<%=template%>'=='<%=templateDefault%>')
						 )
		templateDesc[<%=i%>] = <%=((String)templateDesc.get(i))%>	//convertForSource done
		templateModule[<%=i%>] = '<%=((String)templateModule.get(i))%>'
		templateEditForm[<%=i%>] = '<%=((String)templateEditForm.get(i))%>'
		templateExtension[<%=i%>] = '<%=((String)templateExtension.get(i))%>'
		templateModuleLinkField[<%=i%>] = '<%=((String)templateModuleLinkField.get(i))%>'
		templateFilenameField[<%=i%>] = '<%=((String)templateFilenameField.get(i))%>'
		templateNames[<%=i%>] = '<%=template%>'
		templateImagePaths[<%=i%>] = '<%=templateImageList.get(i)%>'

		if ('<%=template%>'=='<%=templateDefault%>') origLinkModule = templateModule[<%=i%>]


		<%
		if(useTemplateThumbnails && template !=null && template.equals(templateDefault)) {
		%>
			setTemplateImage(<%=i%>);
		<%
		}
	}
	//----- For any invalid templates
	for ( int i=0; i<linkTemplates.length; i++ )
	{
		if ( linkTemplatesFound[i].equals("") )
		{%>
			RZselectOptionAdd( document.XMLForm.RZtemplate,
	        		           '<%=linkTemplates[i]%> (Not Found)', '*NA*', false )
	    <%}
	}
	%>
	//----- Initialize template display, type, description
	RZsetDefault( document.XMLForm.RZtemplate, 'linktemplatedefault' )
	if (RZgetLinkProperty('linkurldefault').substr(0,1) == '#')
		RZsetDefault( document.XMLForm.RZcreateanchor, 'linkurldefault' )
	else
		RZsetDefault( document.XMLForm.RZurl, 'linkurldefault' )

	if (RZgetFieldValue( document.XMLForm.RZtemplate) != '*NONE*' )
		RZsetFieldValue( document.XMLForm.RZlinkType, 'template' )

	if (document.XMLForm.RZtemplate.options.length == 2) {//if only one choice
		RZsetfieldvalue(document.XMLForm.RZtemplate,document.XMLForm.RZtemplate.options[1].value);
		<%
		if(useTemplateThumbnails) {
		%>
			setTemplateImage(document.XMLForm.RZtemplate.options[1].value);
		<%
		}
		%>
	}
	templateChange();
	<%
	//----- Get pathname if filename allowed
	if (usePathFilename)
	{
		%>
		RZsetDefault( document.linkfilenameForm.linkfilename, 'linkfilenamedefault')

		//----- Save converted original name to know if need to save record
		origLinkFilename = document.linkfilenameForm.linkfilename.value;

		//----- If pathname supplied, remove from filename because it will be pre-pended
		//		when continue button clicked.
		var linkfilename = document.linkfilenameForm.linkfilename.value
		if (linkfilename.indexOf(linkpathname) == 0) //if starts with pathname
		{
			linkfilename = RZsubstring(linkfilename,linkpathname.length)
			document.linkfilenameForm.linkfilename.value = linkfilename
		}
		else if (linkfilename != '' && linkfilename.indexOf('/') != 0 && linkpathname != ''
		&& linkpathname.substring(linkpathname.length)!='/')
			document.linkfilenameForm.linkfilename.value = '/' + linkfilename
		else if (linkfilename != '' && linkfilename.indexOf('/') != 0 && linkpathname != ''
		&& linkpathname.substring(linkpathname.length)=='/')
			document.linkfilenameForm.linkfilename.value = linkfilename
		<%
	}
	else
	{
		%>
		RZsetfieldvalue( document.XMLForm.linkfilename, '')
		<%
	}
} //end template
/* 04-29-2013
else if (linkoptions.indexOf(",url,") != -1)
{
	useTarget = true;
}
if (useTarget == true)
{
	%>
	//----- Copy value from XMLForm to controlForm
	origLinkTarget = "<%=linkTarget%>";
	if (origLinkTarget == ' ') origLinkTarget = '';		//Oracle cludge

	if (RZ.editaction != 'create')
	{
		if (origLinkTarget == 'on' || origLinkTarget == 'true')
			RZsetfieldvalue(document.controlForm.linktarget,'on')
		else
			RZsetfieldvalue(document.controlForm.linktarget,'off')
	}
	if (origLinkTarget == 'off' || origLinkTarget == 'false') origLinkTarget = ''
	<%
*/
if (rz.isvalidfield(listModule,"linktarget"))
{
	%>
	//----- Init origLinkTarget
	origLinkTarget = "<%=linkTarget%>";
	if (origLinkTarget == ' ') origLinkTarget = '';		//Oracle cludge
	if (origLinkTarget == 'off' || origLinkTarget == 'false') origLinkTarget = '';
	RZsetfieldvalue('linktarget',origLinkTarget)
	<%
}
%>
	//----- Set url link
	if (RZgetfieldvalue( document.XMLForm.RZlinkType ) == 'url')
		RZsetfieldvalue( document.XMLForm.RZurl, <%=linkPage%> )

	//----- Move focus to link display text if new record
	document.XMLForm.RZtext.focus();

	//----- Call user editform setup if defined
	if (typeof parent.RZlinkmanagersetup == 'object')
	{
		document.XMLForm.linkdisplay.value = document.linkfilenameForm.RZtext.value
		<% if (usePathFilename) { %>
			document.XMLForm.linkfilename.value = document.linkfilenameForm.linkfilename.value
		<% } %>
		msg = parent.RZlinkmanagersetup(document.XMLForm);
		if (typeof msg == 'undefined') msg = '';

		document.XMLForm.RZtext.value = document.XMLForm.linkdisplay.value
		//04-29-2013
		//document.controlForm.linktarget.value = document.XMLForm.linktarget.value
		<%
		if (usePathFilename)
		{
			%>
			document.linkfilenameForm.linkfilename.value = document.XMLForm.linkfilename.value
			<%
		}
		%>
	}

<%
if (usePathFilename)
{
	%>
	// Netscape 4 needs resize handler because layers are lost
	if (RZ.isnavigator && RZ.browserversion < 5) onresize = RZpageResize;
	<%
}
%>
	//----- If auto save enabled, do it
	if (!RZ.trace && RZgetfieldvalue( document.controlForm.linkautocontinue) != '')
	{
		linkSelect()
	}
	else 	// otherwise ive focus to linkdisplay field
		document.XMLForm.RZtext.focus();

	parent.document.title += ' (' + linkplacement + ')';
	
	// tinyMCE 5 Support
	window.top.postMessage(JSON.stringify({ eventType : "ready" }));
}


/*---------------------------------------------------------------------------------------------
Update XMLForm fieldName from set value if one is specified
---------------------------------------------------------------------------------------------*/
function RZfieldRepair(fieldName)
{
	var msg = '';
	if (typeof RZ.setvalues != 'undefined'
	&& typeof RZ.setvalues[fieldName] != 'undefined'
	&& RZ.setvalues[fieldName] != 0
	&& document.XMLForm[fieldName].value != RZ.setvalues[fieldName])
	{
		msg = fieldName + " " + document.XMLForm[fieldName].value
			+ ' --> ' + RZ.setvalues[fieldName] + '\n'
		document.XMLForm[fieldName].value = RZ.setvalues[fieldName]
	}
	return msg;
}
/*---------------------------------------------------------------------------
If form field is blank use default value if one is specified
----------------------------------------------------------------------------*/
function RZsetDefault(field,property,overwrite)
{
	if (typeof overwrite == 'undefined') overwrite = false
	var value = RZgetLinkProperty(property)
	if (value == '') return

	if (!overwrite)
	{	// if not forced overwrite, then return if field already has valid value
		var fieldvalue = RZgetfieldvalue(field)
		if (fieldvalue != '' && fieldvalue != '*NONE*')	return
	}
	RZsetfieldvalue( field, value)					//set to default value
}
/*---------------------------------------------------------------------------
Return link manager property if defined; otherwise return null
----------------------------------------------------------------------------*/
function RZgetLinkProperty(property)
{
	if (!RZwinaccess(parent.parent)
	|| typeof parent.parent.RZ == 'undefined'
	|| typeof parent.parent.RZ.link['<%=linkname%>'] == 'undefined'
	|| typeof parent.parent.RZ.link['<%=linkname%>'][property] == 'undefined')
		return ''

	return parent.parent.RZ.link['<%=linkname%>'][property]
}
/*---------------------------------------------------------------------------
Sets template properties and validates user specified filename configuration
----------------------------------------------------------------------------*/
function templateChange()
{
	var opt = RZgetFieldValue( document.XMLForm.RZtemplate )
	var desc = ''
	if (opt >= 0) desc = templateDesc[opt]
	RZsetFieldValue( document.XMLForm.RZdescription, desc )

	newSectionChange(RZgetfieldvalue('RZlinkType'));	//04-29-2013
	templateFieldnameFieldCheck(opt)
}
/*---------------------------------------------------------------------------
Called when type changes (not currently called for none or file)
	value is url, insertanchor, createanchor or template
----------------------------------------------------------------------------*/
function changeType(value)
{
	//changeNewWindow(value);			//04-29-2013
	newSectionChange(value);			//	 ''
	if (value != 'template')
	{
<% if (linkoptions.indexOf(",template,") != -1){%>
	/* 04-29-2013
		RZshowlayer( 'linknewsectionLayer', false)
	*/
<% } %>
<% if (usePathFilename){%>
		RZshowlayer( 'linkfilenameLayer', false)
<% } %>
	}
	else
	{
		var opt = RZgetFieldValue(document.XMLForm.RZtemplate)
		templateFieldnameFieldCheck(opt)
	}
}
/*---------------------------------------------------------------------------
Open newSectionPopupLayer with senario specific prompts, suggestions and
requirements.

if topnav link in home section
	if create, force new section (don't even show prompt)
	*if update and currently same section, offer new section
	else show new section greyed out choices
if topnav and not home section
	if create, default new section; offer same section
	*if update and currently same section, offer new section
	else show new section greyed out choices
if not topnav
	if create, default same section; offer new section
	*if update and currently same section, offer new section with warning
	else show new section greyed out choices

which means:
	if update
		and currently same section, offer new section
		else show new section w/o option to change
	else if create
		if topnav
			in home sec, new section no prompt
			default new section, option to change
		else
			default same section, option to change
----------------------------------------------------------------------------*/
function newSectionChange(type)					//04-29-2013
{
	var linknewsection = document.linknewsectionForm.linknewsection;
	var linknewsectionAllowed = document.controlForm.linknewsection.value;
	var templateName = RZgetFieldValue('RZtemplate', 'text');

	var showSectionLayer = 	false;
	var isSectionChoice = false;
	var isSectionNote = false;
	var isNewSection = false;
	var hideSameSection = false;
	var isNewSectionForced = false;
	if (!RZ.repair
	&& (linkparentid == 0 || /fullwidth/i.test(templateName)))
		isNewSectionForced = true;

	RZshowlayer('newSectionPopupWarn',false);
	RZshowlayer('newsection-home',false);
	RZshowlayer('newsection-parent',false);

	//----- template allows new section and not RTE call (not yet allowed for RTE)
	if (type == 'template' && templateName.indexOf('--') != 0 && !isRTE
	&& (linknewsectionAllowed == '*all*'
	|| RZcheckOptions(linknewsectionAllowed, templateName+',*'+templateName)))
	{
		showSectionLayer = true;
		if (RZ.editaction == 'update')		//update
		{
			isNewSection = (RZgetfieldvalue(linknewsection) == 'on')
			if (origLinkNewSection != 'on')		//currently same section, option to change
			{
				isSectionChoice = true;
			}
			else
			{
				if (isNewSectionForced)			//in home sec, no prompt
					showSectionLayer = false;

				//hideSameSection = true;
				//RZshowlayer('newsection-oncesaved',false);
			}
		}
		else								//create
		{
			if (isNewSectionForced)				//in home sec, no prompt
			{
				isNewSection = true;
				showSectionLayer = false;
			}
			else		//not home - default same section, option to change
			{
				isSectionChoice = true;
				if (!RZ.repair && linkparentid == 0)
					isNewSection = true;
				newSectionPopup('create');
			}
		}
	}

	RZsetfieldvalue(linknewsection, isNewSection?'on':'off')
	if (RZisadmin() || RZ.editaction == 'create')	//02-13-2014 DCO
	{
		RZshowlayer('linknewsectionLayer',showSectionLayer);
		RZshowlayer('newsection-samelinks',!hideSameSection);
	}
	document.linknewsectionForm.linknewsection[0].disabled = !isSectionChoice;
	document.linknewsectionForm.linknewsection[1].disabled = !isSectionChoice;
	if (showSectionLayer)
	{
		if (isNewSection)
			RZshowlayer('newSectionPopupWarn',true);
		if (linkparentid == 0)
			RZshowlayer('newsection-home',true);
		else
			RZshowlayer('newsection-parent',true);
	}
	return isNewSection;
}
/*-----------------------------------------------------------------------------
Display new section popup layer if not administrator and yes selected
mode: more, yes, no
-----------------------------------------------------------------------------*/
function newSectionPopup(mode)					//04-29-2013
{
	var show = true;
	var linknewsection = document.linknewsectionForm.linknewsection;

	RZshowlayer('newsection-parentlinks',false);
	RZshowlayer('newsection-topnav-create',false);
	RZshowlayer('newsection-leftnav-create',false);

	switch (mode)
	{
		case 'more':		//more details on section
		{
			if (RZgetfieldvalue(linknewsection) == 'on')
				RZsetfieldvalue(linknewsection,'off')
			RZshowlayer('newsection-parentlinks',true);
			RZshowlayer('newSectionPopupWarn',false);
			break;
		}

		case 'create':
			if (linkplacement.indexOf('topnav') != -1)
				RZshowlayer('newsection-topnav-create',true);
			else
				RZshowlayer('newsection-leftnav-create',true);
			break;

		case 'yes':
			RZshowlayer('newSectionPopupWarn',true);
			show = false;
			break;

		case 'no':
			RZsetfieldvalue(linknewsection,'off')

		default:
			RZshowlayer('newSectionPopupWarn',false);
			show = false;
	}
	//too much for now
	//RZshowlayer(document.getElementById('newSectionPopupLayer'),show);
}
/*---------------------------------------------------------------------------
Called to change filename when template changes or linkdisplay changes.
Also called when new section selection changes to force a new folder.
----------------------------------------------------------------------------*/
function changeFilename()
{
<% if(usePathFilename){%>
	if (RZ.editaction == 'create'
	|| document.linkfilenameForm.linkfilename.value == '' || origLinkType == 'url')
	{
		var value = RZtrim(document.XMLForm.RZtext.value)
		value = RZvalidfilename(value).replace(/_?&+_?/g,'_and_');
		value = RZvalidfilename(value).replace(/^_+/g,'');
		value = RZvalidfilename(value).replace(/_+$/g,'');
		value = value.replace(/\s+/,'_').toLowerCase();		//only inserts single _ for whitespace
		value = RZvalidateString(value, 'correct,firstchar=_,validchars=/<%=validfilecharacters%>');

		// DCO 07-05-2009: superceeded by above code to disallow &
		//value = RZvalidfilename(value)

		/* superceeded by above call to RZvalidfilename()
		value = RZreplaceAll(value, ' ', '_').toLowerCase()
		var len = value.length
		value = RZvalidateString(value, 'correct,firstchar=_,validchars=()_-')
		value = RZsubstring(value,0,len)	//overcome bug with correct mode
		*/

		document.linkfilenameForm.linkfilename.value = value
	}
<% } %>
}
/*---------------------------------------------------------------------------
linkid	-999 if unique template
		>0 if dependent template
		0, -1 or undefined if not template
----------------------------------------------------------------------------*/
function changeLinkTarget(linkid)			//04-29-2013
{
	if (!linkid) linkid = 0;				//undefined if not linkProcessRTE call

	var target = '';
	if (newLinkType == 'file')				//uploaded file
		target = 'true';

	else if (linkid == -999 || linkid > 0)	//template
		target = '';

	else if (newLinkType == 'url')			//url check domain
	{
		var pattern = new RegExp("(https?://)(www.)?(.*?)(/|$).*","m");
		var domain = '<%=liveChannelUrl%>'.replace(pattern,'$3');
		if (domain != document.XMLForm.RZurl.value.replace(pattern,'$3'))
			target = 'true';
	}

	return target;
}
/*---------------------------------------------------------------------------
----------------------------------------------------------------------------*/
function templateFieldnameFieldCheck(opt)
{
<% if(usePathFilename){%>
	showFlag = false;
	//DCO 04-29-2013
	//showSection = false;

	if (opt != "*NONE*" && templateFilenameField[opt] != '')
	{
		if (RZgetFieldValue( document.XMLForm.RZlinkType) == 'template')
		{
			var msg = ''
			var templateName = RZgetFieldValue( document.XMLForm.RZtemplate, 'text' )
			var fieldName = templateFilenameField[opt]
			if (templateModule[opt] != listModule)
				msg = 'The selected template "'+ templateName +'" must be configured to use\n'
				    + 'the same dependent module used by this link manager screen.\n'
				    + '(this link manager screen is using module: ' + listModule +')'
			else if (fieldName != 'linkfilename')
				msg = 'The selected template "'+ templateName +'" must be configured to\n'
					+ 'use a field named "linkfilename" not the field "'+fieldName+'"\n'
					+ 'as is currently selected in the AdminCenter.'

			if (msg != '')
				RZalert('To permit users to specify html filenames:\n' + msg )
			else
			{
				showFlag = true;	//show filename input field

				//----- If selected template OPTIONALLY permits new section,
				// 		Show prompt for user selection if linktosectionid is 0
				// 		(meaning section not yet created) or
				// 		display section prompt for user selection.
				//		As of redmine #1408, also if existing link created new section
				//		(later logic uses RZisvisable to preserve new section)
				var linksectionid = document.XMLForm.linksectionid.value;
				var linknewsection = document.controlForm.linknewsection.value;
				var linktosectionid = document.XMLForm.linktosectionid.value;

				/*DCO 04-29-2013: newSectionChange() displays section prompt if needed
				// Note: linktosectionid will be 0 when field does not exist
				if (RZisadmin()
				&& (linktosectionid == '0' || isSectionChangeAllowed)
				&& (linknewsection == '*all*' || RZcheckOptions(linknewsection, templateName+',*'+templateName)))
					showSection = true;

				else if (linktosectionid != '0' && linktosectionid != linksectionid)
					showSection = true;
				*/
				/* prior to redmine #1408
				if (linktosectionid == '0' || linktosectionid == linksectionid || isSectionChangeAllowed)
				{
					if (linknewsection == '*all*'
					|| RZcheckOptions(linknewsection, templateName+',*'+templateName))
						showSection = true;
				}
				*/
			}
		}
	}
	RZuseFilename = showFlag

	//----- Default filename to linkdisplay
	changeFilename()

	//----- Change visibility
	RZshowlayer( 'linkfilenameLayer', showFlag)

	/*DCO 04-29-2013
	RZshowlayer( 'linknewsectionLayer', showSection || RZ.repair)

	if (RZ.editaction == 'update')
	{
		if (isNewSectionRequired
		&& RZgetfieldvalue(document.linknewsectionForm.linknewsection) != 'on')
			newSectionChange(RZgetfieldvalue('RZlinkType'));
	}
	*/

	/* #1309 added code but later deferred due to questionable value
	if (showSection)
	{
		var disabled = false;
		if (RZcheckOptions(linknewsection, '*'+templateName))
		{
			disabled = true;
			document.linknewsectionForm.linknewsection[0].checked = false;
			document.linknewsectionForm.linknewsection[1].checked = true;
		}
		document.linknewsectionForm.linknewsection[0].disabled = disabled;
		document.linknewsectionForm.linknewsection[1].disabled = disabled;
	}
	*/

<%}%>
}
/*---------------------------------------------------------------------------
Called when page is resized on Netscape (resize handler activated in setup()
Makes linkfilenameLayer visible before resizing because layers will be lost.
----------------------------------------------------------------------------*/
function RZpageResize()
{
	/* DCO 10-19-2012 invalid display test ignore now: block or inline
	// Only called if  RZ.browserversion < 5 which should never happen
	if(document.layers.length > 0
	&& document.layers.linkfilenameLayer.visibility != 'visible')
		RZshowlayer( 'linkfilenameLayer', true)
	*/
	return true
}
/*---------------------------------------------------------------------------
cancel button clicked - give focus to opener if still open

If reload is true, reload opener with hash that save would have used.
----------------------------------------------------------------------------*/
function linkCancel(reload)
{
	//alert ('link Cancel Called');
	if (reload && RZwinaccess(parent.parent) && RZ.editaction == 'update')
	{
		//alert("reload && RZwinaccess(parent.parent) && RZ.editaction == 'update' returns TRUE");
		var saveReturn = RZ.pagemodule + '_rz' + RZ.editrecordid;
		parent.parent.location.hash = saveReturn;
		parent.parent.location.reload(true);
	}
	else
	{
		//alert("reload && RZwinaccess(parent.parent) && RZ.editaction == 'update' returns FALSE");
		RZopenerFocus()
	}
	parent.parent.RZ.tinymce.modal.dialog.close();
}
/*---------------------------------------------------------------------------
Validate user specified path and filename
----------------------------------------------------------------------------*/
function RZvalidateFilename()
{
	var pos = 0;
	var msg = ''

	//----- Only check filename if template selected that uses filenames
	var opt = RZgetfieldvalue( document.XMLForm.RZtemplate )
	if(RZgetfieldvalue(document.XMLForm.RZlinkType) != 'template'
	||templateFilenameField[opt] == '')
		return ''

	//----- Can't proceed with page design flaw
	if(RZuseFilename == false)
	{
		if (opt == '*NONE*')
			return 'Template must be selected';
		else
			return "Can't proceed due to previously reported template page design flaw.\n\n"
			     + 'Try another template.'
	}

	var pathfilename = RZgetfieldvalue(document.linkfilenameForm.linkfilename)
	pathfilename = RZreplace(pathfilename,'\\','/');

	//----- Strip leading slash
	var leadingSlash = '';
	if (pathfilename.length > 0 && pathfilename.substring(0,1) == '/')
	{
		leadingSlash = '/';
		pathfilename = pathfilename.substring(1);
	}

	//----- If dot is last character, discard it
	if (pathfilename.substring(pathfilename.length-1) == '.')
		pathfilename = pathfilename.substring(0,pathfilename.length-1)

	//----- Make sure section response is entered if required
	//		04-29-2012 always has default so check should not be needed
	/* 04-29-2013
	if (RZ.editaction == 'create'
	&& RZisvisible('linknewsectionLayer')
	&& RZgetFieldValue(document.linknewsectionForm.linknewsection) == '')
	*/
	if (RZgetFieldValue(document.linknewsectionForm.linknewsection) == '')
		msg = 'Please indicate if page will start a new section or not.'

	//----- Return if filename is blank
	else if (pathfilename == '')
		msg = 'Filename for html Page Must be Specified'

	//----- Continue if no errors
	else
	{
		var linknewsection = document.controlForm.linknewsection.value;
		var templateName = RZgetFieldValue(document.XMLForm.RZtemplate, 'text');

		//----- If link is new section, note it
		/* 04-29-2013
		if (isSectionChangeAllowed
		&& RZisvisible('linknewsectionLayer')
		&& RZgetFieldValue(document.linknewsectionForm.linknewsection) == 'on')
		*/
		if (RZgetFieldValue(document.linknewsectionForm.linknewsection) == 'on')
			newSection = true;

		/* #1309 updated code but later deferred due to questionable value
		//----- If new section required, set flag
		//		(new section required if linknewsection='*all*' or linknewsection='*templatename')
		if (isSectionChangeAllowed
		&& (RZcheckOptions(linknewsection, '*'+templateName) ))
			newSection = true;
		*/

		//----- On create, if link is new section, treat filename as folder if no folder entered
		if (newSection && origLinkNewSection != "on")
		{
			pos = pathfilename.indexOf("/");
			if (pos == -1)
			{
				pos = pathfilename.lastIndexOf(".");
				if (pos > 0) 	//drop file extension
					pathfilename=pathfilename.substring(0,pos)
				pathfilename += "/";
			}
		}

		//----- Prepend pathname
		var linkpathname = document.controlForm.linkpathname.value;
		if (pathfilename.indexOf(linkpathname) != 0
		&& leadingSlash.indexOf('/') != 0)	//if pathfilename did not start with slash
			pathfilename = linkpathname + pathfilename

		//----- Append index if trailing slash (default extension appended below)
		if (pathfilename.substring(pathfilename.length-1) == '/')
			pathfilename += 'index'

		//----- Filename changes up to here don't need notification
		var pathfilenameOriginal = leadingSlash + pathfilename

		//----- If no extension, append default extension (.htm or .html)
		var filename = pathfilename
		var path = ''
		var pos = pathfilename.lastIndexOf('/')
		if (pos > 0)
		{
			filename = pathfilename.substring(pos+1)
			path = pathfilename.substring(0,pos)
		}

		//----- dependent template file extension
		var opt = RZgetfieldvalue( document.XMLForm.RZtemplate )
		var ext = templateExtension[opt]

		if (filename.indexOf('.') == -1)
		{
			if (ext != '')
				pathfilename += '.' + ext
			else
				pathfilename += '<%=defaultFileExt%>'
		}
	} // end non-blank test

	//----- Store updated path filename
	document.linkfilenameForm.linkfilename.value = leadingSlash + pathfilename

	//----- Check for valid characters (plus / and .)
	if (msg == '')
		msg = RZvalidateString(pathfilename, 'firstchar=_,validchars=<%=validfilecharacters%>./')
	return msg
}
/*---------------------------------------------------------------------------
Upload File button clicked.
----------------------------------------------------------------------------*/
function uploadFile()
{
	RZsetFieldValue(document.XMLForm.RZlinkType,'file')		//set link type
	var filelocation = RZgetFieldValue(document.controlForm.filelocation)

	var options = "location=" + filelocation + ",";

	RZselectFile( 'file',
	              document.XMLForm.linkfile_display,
	              document.XMLForm.linkfile,
				  options);
				  
}

/*---------------------------------------------------------------------------
Upload Image button clicked.
----------------------------------------------------------------------------*/
function uploadImage()
{
	var filelocation = RZgetFieldValue(document.controlForm.filelocation)

	var options = "location=" + filelocation + ",";

	RZselectFile( 'image',
	              document.XMLForm.linkimage_display,
	              document.XMLForm.linkimage,
	              options)
}

/*---------------------------------------------------------------------------
Browse Pages
----------------------------------------------------------------------------*/
// function browsePages()
// {
// 	var url = '/revize/util/fileTree/fileURLList.jsp?webSpaceName=' + RZ.webspace;
// 	var width = '300';
// 	var height = '450';
// 	var scroll = 'no';
// 	//console.log('url='+url);
// 	RZ.win = RZpopupUrl( 'BrowsePageLinks', url, width, height, scroll )
// }

// new Browse Function - DJO - 03/14/2019
var revizeChannelUrl = "<%=revizeChannelUrl%>";
function browsePages()
{
    $("[name='RZlinkType]'").prop("checked", true);
    var windowname = "BrowsePageLinks";
    var url = "/revize/plugins/menus/browser.jsp?siteUrl="+encodeURIComponent(revizeChannelUrl);
    var childWin = RZpopupUrl( windowname, url, '1400', '900', 'yes' );
    childWin.focus();

}
/*---------------------------------------------------------------------------
Continue button clicked.  One of more of the following steps are preformed:
Step 1: Delete prior template instance (if exists and no longer using)
Step 2: Create new template instance (if new button or different template)
Step 3: Create or Update list record linking to template
----------------------------------------------------------------------------*/
function linkSelect()
{
	RZtrace( 'linkSelect (continue button)','')
	var opt = 0
	var msg = ''
	newLinkId = origLinkId
	RZsetLinkId(origLinkId);	//build 90B
	newLinkPage = origLinkPage
	newLinkType = RZgetfieldvalue(document.XMLForm.RZlinkType)
	newLinkDisplay = RZgetfieldvalue(document.XMLForm.RZtext)
	newLinkModule = ''
	//newLinkParent initalized in setup() function
	newSection = false;

	//----- Validate type and text specified
	// Do not display this message for insert anchor
	if(newLinkType == 'insertanchor')					//richedit only
		newLinkDisplay = '<img src="/revize/images/edit/anchor-beg.gif" align="bottom" />'
		               + '<sub>'
		               + RZgetfieldvalue(document.XMLForm.RZinsertanchor)
		               + '</sub>'

	if (newLinkType != 'insertanchor' && newLinkDisplay == '')
		msg = 'Text Displayed for Link Must Be Specified'
	else if (newLinkType == '')
		msg = 'Link Type Must Be Specified'
<% if(usePathFilename){%>
	else
		msg = RZvalidateFilename()
<% } %>
<% if (useTarget){%>
	/* 04-29-2013
	//----- Copy target from controlForm to XMLForm
	var linktarget = RZgetfieldvalue(document.controlForm.linktarget)
	if (linktarget == 'off' || linktarget == 'false') linktarget = ''
	RZsetfieldvalue( document.XMLForm.linktarget, linktarget )
	*/
<% } %>

	//----- Continue if no errors
	if (msg == '')
	{
		//----- Not template link (i.e. url, mailto, upload file)
		if (newLinkType != 'template')
		{
			// if none, clear url, fileid and user specified filename
			if (newLinkType == 'none')
			{
				newLinkPage = ''
				<% if (linkoptions.indexOf(",file,") != -1){%>
					document.XMLForm.linkfile.value = '0'
				<% } %>
				document.XMLForm.linkfilename.value = ''
			}
			// if url, set url; clear fileid and user specified filename
			else if (newLinkType == 'url')
			{
				newLinkPage = RZgetfieldvalue(document.XMLForm.RZurl)
				if(newLinkPage.indexOf("#") != -1){
					if(origLinkId != -1){
						newLinkPage = newLinkPage.substring(0,newLinkPage.indexOf("#")) + " " +
												newLinkPage.substring(newLinkPage.indexOf("#"),newLinkPage.length);
					}
					var newOther = newLinkPage.substring(newLinkPage.indexOf("#"),newLinkPage.length);
					RZsetfieldvalue( document.XMLForm.other, newOther )
				}
				else if(newLinkPage.indexOf(" ") != -1){
					var newOther = newLinkPage.substring(newLinkPage.indexOf(" ")+1,newLinkPage.length);
					RZsetfieldvalue( document.XMLForm.other, newOther )
					//newLinkPage = newLinkPage.substring(0,newLinkPage.indexOf(" "));
				}

				<% if (linkoptions.indexOf(",file,") != -1){%>
					document.XMLForm.linkfile.value = '0'
				<% } %>

				//document.XMLForm.linkfilename.value = linkfilename
			}
			// if create anchor, set url; clear fileid and user specified filename
			else if (newLinkType == 'createanchor')
			{
				newLinkPage = RZgetfieldvalue(document.XMLForm.RZcreateanchor);
				if (!newLinkPage)
				{
					alert('Bookmark (anchor) not specified')
					document.XMLForm.RZcreateanchor.focus();
					return;
				}
				if (newLinkPage.substr(0,1) != '#')
					newLinkPage = '#' + newLinkPage;
				<% if (linkoptions.indexOf(",file,") != -1){%>
					document.XMLForm.linkfile.value = '0'
				<% } %>
				document.XMLForm.linkfilename.value = ''
			}

			// if insert anchor, set url; clear fileid and user specified filename
			else if (newLinkType == 'insertanchor')
			{
				newLinkPage = RZgetfieldvalue(document.XMLForm.RZinsertanchor)
				<% if (linkoptions.indexOf(",file,") != -1){%>
					document.XMLForm.linkfile.value = '0'
				<% } %>
				document.XMLForm.linkfilename.value = ''
			}
			// if file, clear url & user specified filename (leave fileid)
			else if (newLinkType == 'file')
			{
				newLinkPage = ''
				//document.XMLForm.linkfilename.value = ''
			}
		}
		//----- Process template links
		else
		{
			//----- Copy filename from linkfilenameForm to XMLForm
			var linkfilename = ''
			<% if(usePathFilename){%>
			opt = RZgetfieldvalue( document.XMLForm.RZtemplate )
			if (templateFilenameField[opt] != '')
				linkfilename = RZgetfieldvalue(document.linkfilenameForm.linkfilename)
			<% } %>
			<% if (linkoptions.indexOf(",file,") != -1){%>
			//	document.XMLForm.linkfile.value = ''
			<% } %>
			document.XMLForm.linkfilename.value = linkfilename

			//----- Validate template arguments
			opt = RZgetfieldvalue( document.XMLForm.RZtemplate )
			if (opt == '*NONE*')
				msg = 'Template Must be Selected'
			else if (opt == '*NA*')
				msg = 'Selected Template Not Available'

			if (msg == '')
			{
				newLinkPage = RZgetfieldvalue( document.XMLForm.RZtemplate, 'text' )
				newLinkModule = templateModule[opt]
				newEditForm = templateEditForm[opt]
				newModuleLinkField = templateModuleLinkField[opt]
			}
		}
	}

	//----- Call user editform validation, if defined
	if (msg == ''
	&& RZwinaccess(parent.opener)
	&& typeof parent.RZlinkmanagervalidate == 'object')
	{
		msg = parent.RZlinkmanagervalidate(document.XMLForm);
		if (typeof msg == 'undefined') msg = '';
	}

	//----- Report errors or proceed to step 1
	if (msg != '')
		alert(msg)
	else
		linkDeleteLinkRecord()

	return
}
/*---------------------------------------------------------------------------
Determine if any link or data changed
----------------------------------------------------------------------------*/
function hasLinkDataChanged()
{
	var status = true
<% if (rz.isvalidfield(listModule,"linktarget")){%>
	var linktarget = RZgetfieldvalue(document.XMLForm.linktarget)
	if (linktarget == 'off' || linktarget == 'false') linktarget = ''
<%}%>
	if(!newSection
	&& origLinkId == RZlinkId	// newLinkId before build 90B
	&& origLinkType == newLinkType
	&& origLinkPage == newLinkPage
<% if (rz.isvalidfield(listModule,"linkparent")){%>
	&& origLinkParent == newLinkParent
<%}%>
<% if (linkoptions.indexOf(",file,") != -1){%>
	&& origLinkFile == document.XMLForm.linkfile.value
<%}%>
<% if (!linkSeqField.equals("") && rz.fieldtype(listModule,"linkseq") != -1){%>
	&& origLinkSeq == document.XMLForm.<%=linkSeqField%>.value
<%}%>
<% if (usePathFilename){%>
	&& origLinkFilename == document.XMLForm.linkfilename.value
<%}%>
<% if (rz.isvalidfield(listModule,"linktarget")){%>
	&& origLinkTarget == linktarget
<%}%>
	&& origLinkDisplay == newLinkDisplay

	&& origLinkNewSection == RZgetFieldValue(document.linknewsectionForm.linknewsection)

	&& document.XMLForm.linksortkey.value == <%=StringUtils.convertStringForSource(linkSortKey)%>)
		status = false

	return status
}
/*---------------------------------------------------------------------------
STEP 1: TODO: Mark prior instance of template to be deleted if RTE call.
First need to make sure there are not other references.  References from
the calling template should be ignored in this test.
----------------------------------------------------------------------------*/
function linkDeleteLinkRecord()
{
	//----- Skip this step if new link or we can update the current record
	if (isRTE)
		document.XMLForm.linkrte.value == 'yes'
	else
		document.XMLForm.linkrte.value == ''

	//----- Use existing record if possible
	var linkrte = RZtrim( RZgetFieldValue(document.XMLForm.linkrte) )
	if( linkrte == ''					//non-RTE link
	|| RZ.editaction == 'create'		//or new link
	|| hasLinkDataChanged() == false)	//or no changes
	{
		linkCreateLinkRecord()			//...move to Step 2
		return
	}

	RZ.message = ''
	RZmsgAdd( 'linkrte', linkrte )
	RZmsgAdd( 'editaction', RZ.editaction )
	RZtrace( 'linkDeleteLinkRecord',RZ.message)

	//----- New record will be created.  If called from the from RTE, the new
	//		record should be deleted if RTE changes are not saved.
	//RZ.editaction = 'create'

	//----- TODO: Mark existing template status as 'deleted'
	//		Consider using linkmanager_xmp.jsp to change current record status,
	//		which would then call linkCreateLinkRecord() after jsp processing.
	//
	//		If using right frame for jsp code here, consider race condition of
	//		subquently executing a return statement after loading different code
	//		into the right frame.  The linkCreateLinkRecord() function currently
	//		loads different code into the right frame to create template links.
	//
	//		If jsp code is executed as suggested above, the following call to
	//		linkCreateLinkRecord() should be removed
	linkCreateLinkRecord()
	return
}
/*---------------------------------------------------------------------------
STEP 2: Create link and dependent record if needed.

New template instance is created by adding a new (non-working copy)
record to the template's dependent module by calling linkmanager_xml.jsp.

****** ????? ****** (Dave Otto 04-14-2004)
Below was an early design idea that was probably NEVER IMPLEMENTED:
(other CRITICAL things are undoubted done beyond original ideas)

If link module is not the same as the dependent module, records are added to
both the list/link module and the dependent module.

TODO: This function will be called by linkmanager_xmldone.jsp (loaded in the
rightFrame if a link record was marked deleted) therefore returns may attempt
to return to the rightFrame caller (not sure where control will actually go).
----------------------------------------------------------------------------*/
function linkCreateLinkRecord()
{
	var createNewRecord = true;		//set false below if new record not required

	var msg = '';
	RZ.message = ''
	RZmsgAdd( 'editaction', RZ.editaction )
	RZmsgAdd( 'origLinkId', origLinkId )
	RZmsgAdd( 'origLinkType', origLinkType )
	RZmsgAdd( 'origLinkPage', origLinkPage )
	RZmsgAdd( 'origLinkModule', origLinkModule )
	RZmsgAdd( 'newLinkType', newLinkType )
	RZmsgAdd( 'newLinkPage', newLinkPage )
	RZmsgAdd( 'newLinkModule', newLinkModule )
	RZtrace( 'linkCreateLinkRecord (entered)',RZ.message)

	//----- Validate and set template arguments
	if (newLinkType == 'template' && newLinkModule == '')
	{
		msg = 'The selected template does not specify the dependent module\n'
			+ '(it may be a unique template which is not currently supported).'
		RZalert(msg)
		return
	}

	//----- Validate and set template arguments
	if (newLinkType == 'file')
	{
		if (isRTE && RZgetfieldvalue(document.XMLForm.linkfile_display) == ''
		|| !isRTE && RZgetfieldvalue(document.XMLForm.linkfile) == '0')
		{
			msg = 'File must be selected'
			alert(msg)
			return
		}
	}

	//----- If none of link fields have changed...
	if ( !hasLinkDataChanged() )
	{
		linkProcessListRecord()			//...move to Step 3
		return
	}

	//----- If url link (newLinkType changed to urltemplate for revize managed page)
	//		DO 12-29-2005: Prior to build 140 this code was in 3 places
	//		(retained prior logic to skip for existing rte urltemplate links).
	//
	//		TODO: Not sure why this code is not used for exsiting rte urltemplate links.
	if (newLinkType == 'url')
	{
		var absoluteurl = toAbsoluteUrl(newLinkPage);
		if (absoluteurl == null) return;	//error

		RZ.message = '';
		RZ.parameters = '';
		RZaddUrlParameter( 'webspace=' + RZ.webspace );
		RZaddUrlParameter( 'url=' + escape(newLinkPage) );
		RZaddUrlParameter( 'absoluteurl=' + escape(absoluteurl) );
		if (isRTE) RZaddUrlParameter( 'rte=true' );
		RZaddUrlParameter( 'mode=url' );
		RZtrace("linkCreateLinkRecord",RZ.message);

		var url = '../linkmanager_xml.jsp' + RZ.parameters; // 2/19/2020 Go one directory up because we're in the wrong as of this version.

		//----- Load linkmanager_xml.jsp in right frame (mode=url) which calls the java
		//		linkmanager class to determine if this is a Revize managed page or if
		//		the specified url exists.
		//
		//		linkProcessListRecord() is then called by linkmanager_xml.jsp to continue.
		parent.rightFrame.location = url;
		return;
	}

	//----- New link processing...
	if (RZ.editaction == 'create')
	{
		//----- Non template links
		if (newLinkType != 'template' && isRTE)		//and not a template
		{
			if (newLinkType == 'url'	//should not occur as of build 140 (processed above)
			|| newLinkType == 'file'
			|| newLinkType == 'createanchor'
			|| newLinkType == 'insertanchor')
			{
				if(!linkProcessRTE(-1,newLinkPage,''))	//set RTE & return status
				{
					alert( 'Rich Text Editor has been closed.\n\n'
					     + 'Link will not be saved.' )
					RZ.parent.close()	//close link manager, expect return below
				}
				linkCancel()			// link manager cleanup
			}
			else	// should not be able to reach here
				alert('Link Manager not needed to add text with Rich Text Editor')

			return	//TODO: this return may not work when delete coded and called
		}

		//----- For RTE call, all links create new record in case the changes are not saved.
		//		Therefore the linkid is cleared if not using the same template so same filename
		//		is not allowed.  Needed to support rollback if changes are not saved.
		else if (isRTE && origLinkPage != newLinkPage)
		{
			RZsetLinkId( -1 );
		}
	}

	//----- Existing link processing...
	else
	{
		if (newLinkType == 'template')
		{
			RZsetLinkId( origLinkId )

			if (newLinkModule == listModule)
				RZsetLinkId( RZ.editrecordid );

			if (origLinkPage == newLinkPage			//same template
			|| newLinkModule == listModule			//list module
			|| newLinkModule == origLinkModule )	//same dep module
				createNewRecord = false;
			else
				RZsetLinkId( -1 );	//do not allow same filename (build 90B)
		}

		//----- If not template type link, we do not need to create a new record.
		else
			createNewRecord = false;
	}

	//----- Can reuse same link record if not template
	// TODO: what about other references??
	if (newLinkType != 'template')		//none, url or file
		createNewRecord = false;

	//----- Migration call
	else if (RZwinaccess(RZ.parent.opener)
	&& typeof RZ.parent.opener.revize_migration != 'undefined')
	{
		RZ.editaction = 'update';
		createNewRecord = false;
	}

	//----- If template and repair mode
	else if (isRTE && RZ.repair == true)
	{
		RZ.editaction = 'update';
		createNewRecord = false;
	}

	//----- if not existing template link or other type of link
	if (createNewRecord == false)
	{
		linkProcessListRecord()			//...move to step 3
		return
	}

	//----- If template does not use listmodule, create the dependent template record first.
	var mode = 'linkrecord'
	if (newLinkModule != listModule)
	{
		if (RZ.editaction == 'create')
			mode = 'templaterecord'
		else
			mode = 'templaterecordonly'
	}

	//----- Get filename w/o bookmark
	var filename = document.XMLForm.linkfilename.value;
	var pos = filename.indexOf('#');
	if (pos != -1)
		filename = filename.substring(0,pos);

	//----- Create a new record in the link (list) module and the dependent module
	//		(only pass arguments needed to call linkmanager java class; others can
	//		be read from this frame by linkmanager_done.jsp).
	RZ.message = '';
	RZ.parameters = '';
	RZaddUrlParameter( 'webspace=' + RZ.webspace )
	RZaddUrlParameter( 'template=' + newLinkPage )
	RZaddUrlParameter( 'module=' + newLinkModule )
	RZaddUrlParameter( 'linkid=' + RZlinkId );	//prior linkid or -1
	RZaddUrlParameter( 'filename=' + filename )
	RZaddUrlParameter( 'mode=' + mode )
	RZaddUrlParameter( 'rte=' + isRTE );
	RZtrace("linkCreateLinkRecord",RZ.message)

	var url = 'linkmanager_xml.jsp' + RZ.parameters

	//----- Retain the create status after calling linkmanager_xml.jsp.  This is
	//		needed a filter profile update can be requested when the final link
	//		record is save.
	if (RZ.editaction == 'create')
		RZ.linkmanagercreate = true;	//used for filter profile

	parent.rightFrame.location = url	//calls linkmanager class

	//linkProcessListRecord() is called by linkmanager_xmp.jsp to continue.

	return
}
/*---------------------------------------------------------------------------
Used above to convert url to absolute
----------------------------------------------------------------------------*/
function toAbsoluteUrl(absoluteurl)
{
	if (absoluteurl != '')
	{
		if(absoluteurl.indexOf("\\") == 0) return absoluteurl
		if(absoluteurl.indexOf("/") == 0)
			absoluteurl = RZ.page.domain + absoluteurl;
		if ( !RZisAbsoluteUrl(absoluteurl) )
		{
			if(absoluteurl.substring(0,4) == 'www.' || isExternalHttpURL(absoluteurl))
			{
				absoluteurl = 'http://'+absoluteurl;
				//TODO: why is next line needed
				newLinkPage = absoluteurl;
			} else if (RZwinaccess(parent.parent))
			{
				absoluteurl = RZ.page.domain
							+ parent.parent.RZ.page.pathname
							+ '/' + absoluteurl;
			}
			else
			{
				alert('Link Manager caller window closed or refreshed')
				return null
			}
		}
	}
	return absoluteurl
}

/*---------------------------------------------------------------------------
check if the URL has an external domain name (the input url should be without http://www.)
----------------------------------------------------------------------------*/
function isExternalHttpURL(urlstr)
{
	var flag = false;
	//check if the url has : (example mailto:, news: ,callto:, tel: ) - if exits, skip
	var poscolon = urlstr.indexOf(":");

	//check if the url starts with #
	var poshash = urlstr.indexOf("#");

	if(poscolon != -1 || poshash==0){
		flag = false;
		return flag;
	}
	var validTopLevelDomains = [".com",".org",".net",".int",".edu",".gov",".mil"];
	var posfs = urlstr.indexOf("/");
	var posbs = urlstr.indexOf("\\");
	var poss = -1;
	var domainstr = urlstr;
	if(posfs!=-1 && posbs!=-1) {
		if(posfs < posbs) {
			poss = posfs;
		} else {
			poss = posbs;
		}
	} else if(posfs!=-1){
	 	poss = posfs;
	} else if(posbs!=-1){
		poss = posbs;
	}

	if(poss!=-1){
		domainstr = urlstr.substring(0,poss);
	}
	var posdot = domainstr.lastIndexOf(".");
	if(posdot !=-1){
		var topleveldomain = domainstr.substring(posdot);
		var indx = validTopLevelDomains.indexOf(topleveldomain.toLowerCase());
		if(indx!=-1){
			flag = true;
		}
	}
	return flag;
}
/*---------------------------------------------------------------------------
STEP 3: Process List Record.  Create or Update link manager field values.
List record may be created before getting here for template type links:
For RTE template calls, the list record is always created before we get here.
For non-RTE template calls the list record is created if its the same module
as the dependent template module.

Input Parameters stored as globals:
	RZlinkId
	RZurl
----------------------------------------------------------------------------*/
function linkProcessListRecord()
{	
	RZ.message = '';
	RZmsgAdd( 'newSection', '\t' + newSection )
	RZmsgAdd( 'RZlinkId  ', '\t' + RZlinkId )
	RZmsgAdd( 'RZurl     ', '\t' + RZurl )
	RZtrace("linkProcessListRecord (entered)",RZ.message)

	var sectionid = document.XMLForm.linksectionid.value;
	var tosectionid = document.XMLForm.linktosectionid.value;
	if (RZsubstring(sectionid,0,1) == "-") 	//webgen top links are negitive
		sectionid = "0";					//change to 0 for use in this function

	//----- Set/update linktosectionid based on newsection user selection
	//		(currently only true on create requests for template links)
	if (newSection)
	{
		<% if (rz.isvalidfield(rz.pagemodule,"linktosectionid")) { %>
			sectionid = RZlinkId;
		<% } else { %>
			document.XMLForm.linksectionid.value = RZlinkId;
		<% } %>
	}

	//----- If repair mode and not creating new template, update multi-level menu fields.
	//		The following fields are always repaired elsewhere:
	//			-linkfilename is always prepended with linkpathname
	//			-linkparentid is always updated with current parent
	else if (RZ.repair && !RZ.linkmanagercreate)
	{
		var msg = '';
		msg += RZfieldRepair('linklevel')
		msg += RZfieldRepair('linksectionid')
		<% if (rz.isvalidfield(rz.pagemodule,"linktosectionid")) { %>
		msg += RZfieldRepair('linktosectionid')
		<% } %>

		if (msg != '' && (RZ.auto || confirm('Confirm REPAIR for the following fields:\n\n' + msg)))
			document.XMLForm.linksortkey.value = '<%=rz.today("yyyy-MM-dd HH:mm")%> Repair: ' + msg;

		else if (sectionid != 0
		&& <%= rz.isvalidfield(listModule,"linktosectionid") %>	//linktosectionid field exists
		&& document.XMLForm.linktosectionid.value != sectionid)
		{
			msg = "Change linktosectionid from ("
			    + document.XMLForm.linktosectionid.value +") to ("+sectionid+")"

			if (RZ.auto || confirm('Confirm REPAIR operation:\n\n' + msg))
			{
				document.XMLForm.linktosectionid.value = sectionid;
				document.XMLForm.linksortkey.value = '<%=rz.today("yyyy-MM-dd HH:mm")%> Repair: ' + msg;
			}
		}
	}
	else
	{
		sectionid = document.XMLForm.linksectionid.value;
	}

	//-----	For NEW template links (RZ.linkmanagercreate==true) or any other type of link,
	//		if tosectionid is still set to 0 then set tosectionid=sectionid.  This properly sets
	//		tosectionid for new template links but also insures any future use of this record
	//		does not point back to home section (sectionid=0). If sectionid is the home section
	//		(i.e. sectionid=0), then tosectionid still points to the home section.
	document.XMLForm.linktosectionid.value = sectionid;

	/*BOOKMARK //----- set target based on link type (as of DCO 04-2013 no choice)*/
	document.XMLForm.linktarget.value = changeLinkTarget();
<% if (useTarget){%>
	/* 04-29-2013
	//----- If target not specified by user, set default based on link type
	//DCO 04-02-2013: always set since not displayed
	//if (RZgetfieldvalue(document.controlForm.linktarget) == '')
	{
		if (newLinkType == 'url' || newLinkType == 'file')
			document.XMLForm.linktarget.value = 'true';
		else
			document.XMLForm.linktarget.value = '';
	}
	*/
<% } %>

	//----- Save additional list/link module values
	if (linkIdField!='') document.XMLForm[linkIdField].value = RZlinkId
	if (linkTypeField!='') document.XMLForm[linkTypeField].value = newLinkType
	if (linkPageField!='') document.XMLForm[linkPageField].value = newLinkPage
	if (linkDisplayField!='') document.XMLForm[linkDisplayField].value = newLinkDisplay
	if (typeof linkfilename== 'undefined' || linkfilename == 'undefined') linkfilename = '';
	if(linkfilename != '') document.XMLForm.linkfilename.value = linkfilename

	//----- If nextUrl processing is required then build the url parameters
	//		(store data in parent frame for use by linkmanager_return.html)
	var nexturl = '';
	parent.RZ = new Object()
	parent.RZ.nexturl = RZgetfieldvalue( document.controlForm.nexturl )
	if (newLinkType == 'template' && newEditForm != '')
		parent.RZ.nexturl = newEditForm

<% if (!rz.checkoptions(rz.config("menu_system"),"menu-editform") && rz.isvalidfield(listModule,"linktosectionid")){ %>
	//----- Check for newsection processing
	delete RZ.sections;		//in case prior call
	var isSectionEditForm = parent.RZ.nexturl.indexOf('menu-editform.jsp') != -1
						 || parent.RZ.nexturl.indexOf('links_section-editform.jsp') != -1;

	if (newSection || isSectionEditForm)
	{
		if (isSectionEditForm)
			parent.RZ.nexturl = '';

		if (newSection)
		{
			// Folder of current link record
			var folder = document.linkfilenameForm.linkfilename.value;
			var pos = folder.lastIndexOf("/");
			if (pos == -1)
				folder = "";
			else
				folder = folder.substring(0,pos);
			//Added by Aray
			var  sectionname='';
			sectionname = RZtrim(newLinkDisplay);
			sectionname=RZvalidfilename(sectionname).replace(/_?&+_?/g,'_and_');
			sectionname=RZvalidfilename(sectionname).replace(/^_+/g,'');
			sectionname=RZvalidfilename(sectionname).replace(/_+$/g,'');
			sectionname = sectionname.replace(/\s+/,'_').toLowerCase();


			// New sections property used by RZsave() when building xml
			RZ.sections = {
				id: document.XMLForm.linktosectionid.value,
				//name: newLinkDisplay,
				name:sectionname,
				folder: folder

			};
		}
	}
<% } %>
	if( parent.RZ.nexturl != '' )
	{
		RZ.message = '';
		RZ.parameters = ''

		/* TODO: activate to use working copy
		if ( RZ.record.action != 'create' && hasLinkDataChanged() )
		{
			RZ.currentcopystatus = 0					//save as working copy
			RZmsgAdd( 'workingcopy', RZ.currentcopystatus  )
			RZaddUrlParameter( 'workingcopy')			//read as working copy
		}
		*/

		RZaddUrlParameter( 'webspace='  + RZ.webspace )
		RZaddUrlParameter( 'module='   + listModule )
		if (RZ.record.action == 'create')
			RZaddUrlParameter( 'last' )		//TODO: use linkmanager.class
		else
			RZaddUrlParameter( 'recordid='  + RZ.editrecordid )

		parent.RZ.width = RZgetfieldvalue( document.controlForm.popupwidth)
		parent.RZ.height = RZgetfieldvalue( document.controlForm.popupheight)
		parent.RZ.scroll = RZgetfieldvalue( document.controlForm.popupscroll)

		RZmsgAdd( 'width '  , '\t' + parent.RZ.width )
		RZmsgAdd( 'height'  , '\t' + parent.RZ.height )
		RZmsgAdd( 'scroll'  , '\t' + parent.RZ.scroll )

		//----- Trace parameters used to call user specified nexturl
		RZtrace("linkProcessListRecord (nexturl parameters)",RZ.message)
		parent.RZ.nexturl += RZ.parameters
		nexturl = '/revize/util/linkmanager_return.html' + escape('#nexturl');
	}

	//----- Validate data even if it has not changed
	if (!validateLinkProperties()) return;
<%
if (!rz.permissions_module.equals("")
&& rz.isvalidfield(listModule,"linklevel")
&& rz.isvalidfield(listModule,"linksortkey"))
{
	%>
	//----- if linkparent property does not match the parent_key as defined in
	//		webspace_page_permissions table, force a record update by changing
	//		the linksortfield field to the current date/time.
	if (RZ.editaction == 'update'
	&& RZ.repair) 		//see note below
	{
		var expectedParent = ''
		if (document.XMLForm.linktype.value == 'template')
		{
			<%
			String repair_parent = "";
			//int repair_parentid = StringUtils.toInt(rz.fetch(listModule,"linkparentid","report"));
			int repair_parentid = -1;
			if (StringUtils.toInt(rz.fetch(listModule,"linklevel","report")) > 0)
				repair_parentid = StringUtils.toInt(rz.fetch(listModule,"linkparentid","report"));
			if (repair_parentid > 0)
			{
				String repair_linkid = rz.fetch(listModule,"linkid","report,recordid=" + repair_parentid);
				String repair_template = rz.fetch(listModule,"linkpage","report,recordid=" + repair_linkid);
				repair_parent = repair_template + "[" + repair_linkid + "]";
			}
			%>
			if (<%=repair_parentid%> > 0) 	//repair_parentid > 0
				expectedParent = '<%=repair_parent%>';
			else
				expectedParent = RZgetLinkProperty("linkparent");
		}

		if (expectedParent != '' && expectedParent != '<%=repair_parent_key%>')
		{
			var msg = 'record: webspace_page_permissions page_key=<%=repair_page_key%>\n'
					+ 'update parent_key: <%=repair_parent_key%> --> '
					+ expectedParent;

			// DO 01-04-2006 TODO: undecided if this should be a prompt or automatic.
			// Display prompt if (repair or template) and not auto update; if confirm is false,
			// leave as is so next update gets another choice.
			var update = true;
			if (RZ.repair && !RZ.auto)
				update = confirm('Confirm following REPAIR Operation:\n\n' + msg)
			if (update)
			{
				document.XMLForm.linksortkey.value = '<%=rz.today("yyyy-MM-dd HH:mm")%>: '
												   + RZreplace(msg,'\n',' ')	//newline for display only
				document.XMLForm.linkparent.value = expectedParent;
				newLinkParent = expectedParent;
			}
		}
	}
	<%
}
if (rz.isvalidfield(listModule,"linkparentid")
&& rz.isvalidfield(listModule,"linkparent")
&& rz.isvalidfield(listModule,"linklevel"))
{
	%>
	//------ Always create linkparent from parentid and parent template
	if (document.XMLForm.linktype.value == 'template')
	{
		<%
		String repair_parent = "";
		//int repair_parentid = StringUtils.toInt(rz.fetch(listModule,"linkparentid","report"));
		int repair_parentid = -1;
		if (StringUtils.toInt(rz.fetch(listModule,"linklevel","report")) > 0)
			repair_parentid = StringUtils.toInt(rz.fetch(listModule,"linkparentid","report"));

		while (repair_parentid > 0)
		{
			// if this links parent is not template or urltemplate link then use the grandparent link
			String repair_linktype = rz.fetch(listModule,"linktype","report,recordid=" + repair_parentid);
			if (repair_linktype.indexOf("template") == -1)
			{
				repair_parentid = StringUtils.toInt(rz.fetch(listModule,"linkparentid","report,recordid=" + repair_parentid));
				if (repair_parentid == 0)
				{
					repair_parent="index[]";
					break;	//can't rely on parentid=0
				}

				// if grandparent is not template or urltemplate, bail out
				repair_linktype = rz.fetch(listModule,"linktype","report,recordid=" + repair_parentid);
				if (repair_linktype.indexOf("template") == -1) break;
			}
			String repair_linkid = rz.fetch(listModule,"linkid","report,recordid=" + repair_parentid);
			String repair_template = rz.fetch(listModule,"linkpage","report,recordid=" + repair_linkid);
			repair_parent = repair_template + "[" + repair_linkid + "]";
			break;
		}
		%>
		if (<%=repair_parentid%> >= 0) 	//linkparent key built
		{
			newLinkParent = '<%=repair_parent%>';
			if (newLinkParent != '')
				RZsetfieldvalue( document.XMLForm.linkparent, newLinkParent )
		}
	}
	<%
}
%>
	//----- If link data has changed, update RTE and submit save request
	if ( hasLinkDataChanged() )
	{
		if (isRTE)
		{
			var recordid = RZlinkId
			if (newLinkModule != listModule)
				recordid = RZ.editrecordid
			var url = RZurl
			if (newLinkType == 'url')
			{
				recordid = 0
				url = newLinkPage
			}

			/*BOOKMARK linkProcessRTE hasLinkDataChanged*/
			if ( !linkProcessRTE( recordid, url, (newLinkType=='template' ? newLinkPage : '') ) )
			{
				alert( 'Rich Text Editor window has been closed.\n\n'
				     + 'Rich Text could not be updated\n'
				     + '('+url+' Page may not publish)' )
			}
		}

		//----- If template link type, pass template & parent_key to save
		//		(parent_key passed via the link's linkparent property)
		if (newLinkType == 'template')
		{
			RZ.permissions_parent = newLinkParent
			RZ.permissions_template = newLinkPage
		}
		else if (newLinkType == 'url')
		{
			RZ.permissions_parent = ''
			RZ.permissions_template = ''
		}

		/* Alec: 06/05/2020
		This will need to be revisited in the future to call when the save is actually complete. Right now it calls the callback too early in the save process
		*/
		var tempFn = function(){
			setTimeout(function(){
				parent.parent.RZ.tinymce.modal.dialog.close();
			}, 1200);
		}
		RZ.callback = tempFn();
		RZsave( document.XMLForm, '');
	}

	//----- If link data has not changed - call nexturl or quit
	else if (parent.RZ.nexturl != '')
	{
		if (parent.RZ.width != '' || parent.RZ.height != '')
			RZresize(parent.RZ.width,parent.RZ.height,'',parent.window);
		window.parent.location.replace( parent.RZ.nexturl )
	}
	else
		linkCancel(true)
}
/*---------------------------------------------------------------------------
Process Data for RTE call
----------------------------------------------------------------------------*/
function linkProcessRTE(linkid,url,template,other)
{
	
	var href = 'rz:link';			//means to convert to rz:link tag
	var target = changeLinkTarget(linkid);		//04-29-2013
	if (target != '') target = '_blank';		//	 ''

	/* 04-29-2013
	var target = ''
<% if (useTarget){%>
	target = RZgetfieldvalue(document.controlForm.linktarget);
	if (target == 'off' || target == 'false')
		target = ''

	else if (target == '')	//intelligent default if not specified
	{
		if (linkid == -999 || linkid > 0)
			target = ''
		else
			target = '_blank'
	}
	else
		target = '_blank'
<% } %>
	*/

	var file = '';
	var module = listModule;
	var recordid = linkid;
	if( newLinkType == 'createanchor')
	{
		target = '';
		module = '';
		recordid = '';
		href = url;
	}

	if (newLinkType == 'template')
	{
		template = '';
	}
	else if (newLinkType == 'file')	//file link
	{
		file = RZ.imagePathFilename
		module = '';
		recordid = '';
		template = '';
	}
	else if (recordid == -1)		//if non-revize url link, set url & clear module
	{
		href = url;
		module = '';
		recordid = '';
		template = '';
		if (href.indexOf("tel:") == 0) {
			target = ''; // Tel Links with Target break on Android browsers.
		}
	}

	RZ.message = 'linkdisplay = ' + newLinkDisplay + '\n'
			   + 'newLinkType = ' + newLinkType + '\n'
			   + 'href = ' + href + '\n'
			   + 'target = ' + target + '\n'
			   + 'module = ' + module + '\n'
			   + 'recordid = ' + recordid + '\n'
			   + 'file = ' + file + '\n'
			   + 'template = ' + template + '\n'
	           + 'other = ' + other + '\n';
	RZtrace( 'Link Manager Setting RTE Values', RZ.message );

	if(!RZwinaccess(RZ.parent.parent)) return false;
	insertAction(newLinkType, newLinkDisplay, href, target, module, recordid, file, template, other);
	return true;
}
/*------------------------------------------------------------------------------
Create or update link in tinyMCE. Adapted from the function of the same name in
advLink plugin. Updated for v3.0 on 2008-05-19 by Nick M
Does not get called if opener is closed.
------------------------------------------------------------------------------*/
function insertAction(linktype, linkdisplay, href, target, module, recordid,
                      file, template, other)
{
	var EDITOR_INDEX = typeof RZ.opener !== 'undefined' && RZ.opener !== '' &&  /\d/.test(RZ.opener) ? parseInt(RZ.opener.substr(RZ.opener.lastIndexOf("_") + 1)) : 0;
	//alert('EDITOR INDEX: ' + EDITOR_INDEX);
	var msg = '';
	var elm, elementArray, i;
	var inst = parent.parent.RZ.tinymce;
	var ed = parent.parent.tinymce.editors[EDITOR_INDEX];

	elm = parent.parent.tinymce.editors[EDITOR_INDEX].selection.getNode();
	var tinyDom = parent.parent.tinymce.editors[EDITOR_INDEX].dom;
	var focusElm = ed.dom;
	var selectedElm = parent.parent.tinymce.editors[EDITOR_INDEX].selection.getNode();

	href = checkPrefix(href); // NJM mod

	elm = tinyDom.getParent(elm,'A');

	// Remove element if there is no href
	// NJM: I don't think this will ever happen...
	// DCO 09-23-2014: can get here if url not found and cancel clicked
	if (!href)
    {
		ed.execCommand("mceBeginUndoLevel");
		i = ed.getBookmark();
		tinyDom.remove(elm, 1);
		ed.moveToBookmark(i);
		ed.execCommand("mceEndUndoLevel");
		//inst.modal.dialog.close();
		//top.tinyMCEPopup.close();
		return;
	}

	ed.execCommand("mceBeginUndoLevel");

	//----- update existing link properties
	if (elm != null){
		console.log('elm != null');
		setAllAttribs(elm);

	}
	//----- Create new link
	else
	{
		console.log('elm === null');
		//DCO 09-23-2014:
		//----- When img tag had optional attributes link did not get created.
		//		Fixed by removing most img attributes before creating link
		//		then restoring after link created.  Not sure which attribute
		//		at fault so just removed most.
		var attributes = {};
		if (selectedElm && selectedElm.nodeName === 'IMG')	// remove attributes
		{
			console.log('Image section');
			var allowed = 'title,src,alt';
			for (var i=0;i<selectedElm.attributes.length;i++)
			{
				var attr = selectedElm.attributes[i].name;
				if (!attr || attr.indexOf('data-mce') == 0 || RZcheckoptions(allowed,attr))
					continue;

				attributes[attr] = selectedElm.getAttribute(attr);
				selectedElm.removeAttribute(attr);
			}
			console.log(attributes);
		}
		//----- wrap selection with a tag containing href=#mce_temp_url#
		//		think #mce_temp_url# evaluated as edit page url with hash #mce_temp_url#
		ed.execCommand("CreateLink", false, "#mce_temp_url#", {skip_undo : 1});

		// DCO 09-23-2014: my best understanding is grep() returns array only
		//				   containing the a tag element created above.
		elementArray = top.tinymce.grep(
							// below function creates an object of all a tags
							tinyDom.select("a"),
							// grep then calls below function for each obj element
							// building array of a tags with href of '#mce_temp_url#'
							function(n)
						   	{
								//debugger
								return tinyDom.getAttrib(n, 'href') == '#mce_temp_url#';
        					});

		// Set attributes on newly created link (a tag) to LM values
		for (i=0; i<elementArray.length; i++)
			setAllAttribs(elm = elementArray[i]);

		// DCO 10-24-2015: above does not work on IE11 when <td> selected
		if (!elm)
		{
			elm = ed.selection.getNode();		//get a tag link the easy way
			setAllAttribs(elm);
		}

		//----- restore atttributes removed from img element; restoring
		//		set RZresizeImage.time to resizing if height or width restored
		//		may not need with latest if added to top of RZresizeImage()
		parent.parent.RZresizeImage.img = focusElm;
		parent.parent.RZresizeImage.time = new Date().getTime();
		for (attr in attributes)
			elm.setAttribute(attr, attributes[attr]);
	}

	// null if elementArray empty for new link (link probably not created)
	if (!elm)
		msg = 'Technical Difficulty Creating or Updating Link';

	else
	{
		
		// Don't move caret if selection was image
		if (elm.childNodes.length != 1 || elm.firstChild.nodeName != 'IMG')
		{
			//inst.focus();
			ed.selection.select(elm);
			ed.selection.collapse(0);
			//inst.storeSelection(); 2/19/2020 - Update to tinymce.getBookmark?
		}
	}
	// alert('trigger close here');
	ed.execCommand("mceEndUndoLevel");
	//top.tinyMCEPopup.close();
	//inst.modal.dialog.close();

	if (msg) alert(msg);
	//-------------------------------------
	return;
	//-------------------------------------

    //----- INTERNAL FUNCTIONS -----//
    function checkPrefix(n)    // NJM mod
    {
    	if (n && isEmail(n) && !/^\s*mailto:/i.test(n)
        && confirm(inst.getLang('advlink_dlg.is_email')) )
    		n = 'mailto:' + n;

    	if ( /^\s*www./i.test(n)
        && confirm(inst.getLang('advlink_dlg.is_external')) )
    		n = 'http://' + n;

        return n;

        function isEmail (s) {
            var p = '^[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+@[-!#$%&\'*+\\/0-9=?A-Z^_`a-z{|}~]+\.[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+$';
            s = s.nodeType == 1 ? s.value : s;
            return s == '' || new RegExp(p).test(s);
        }
    }

    function setAllAttribs(elm)
    {
        setAttrib(elm, 'href', href);
        setAttrib(elm, 'mce_href', href);
        setAttrib(elm, 'title');
        setAttrib(elm, 'target', target == '_self' ? '' : target);
        setAttrib(elm, 'recordid', recordid);
        setAttrib(elm, 'module', module);
        setAttrib(elm, 'file', file);
        setAttrib(elm, 'template', template);
        setAttrib(elm, 'other', other);

        if (linkdisplay.indexOf("..") != 0)	// If not image link
        	if (RZ.MSIE)
	        	elm.innerText = linkdisplay;
	        else
            	elm.innerHTML = linkdisplay;

        function setAttrib(elm, attrib, value)
        {
            if (typeof(value) == "undefined" || value == null)
                value = tinyDom.getAttrib(elm, attrib.toLowerCase(), "");

            tinyDom.setAttrib(elm, attrib, value);
        }
    }
}
/*---------------------------------------------------------------------------
Validate data for incongruent or potentially properties that may mess up link
hierarchy and/or page permissions.
----------------------------------------------------------------------------*/
function validateLinkProperties()
{
	var msg = '';

<% if (rz.isvalidfield(listModule,"linktosectionid")) { %>
	//----- linktosectionid cannot be 0 unless sectionid is 0
	if (newLinkType == 'template')
	{
		var sectionid = document.XMLForm.linksectionid.value
		var tosectionid = document.XMLForm.linktosectionid.value
		if (sectionid != 0 && tosectionid == 0 && document.XMLForm.linklevel.value != 0)
			msg = '-Link attempts to create home section (linktosectionid=0)'
		else if (sectionid != tosectionid && tosectionid != RZlinkId)
			msg = '-Invalid new section (linktosectionid='+tosectionid+')'
	}
<% } %>
	//----- Display error message and cancel submit
	if (msg != '')
	{
		msg = 'The link manager cannot process this request for the following reason:\n\n'
			+ msg + '\n\n'
			+ 'Contact your Revize Administrator.'
		RZnote(msg)
		return false;
	}

	return true;
}
/*--------------------------------------------------------------------------*/
</script>
</head>
<body onLoad="setup();" id="linkmanager">
	  <form name="XMLForm" method="post" action="" class="form-horizontal">

		<h1>Link Manager</h1>
			 <p class="page-header">
			<script language="JavaScript">
			if (RZ.editaction == 'create')
				document.write('Create New')
			else
				document.write('Update Existing')
			</script>
           	Link to a Page or File
			<a href="javaScript:debugMode()" style="text-decoration:none">&nbsp;&nbsp;&nbsp;</a></p>
			  <input type="hidden" name="XMLString">
			  <input type="hidden" name="<%=linkIdField%>">
			  <input type="hidden" name="<%=linkTypeField%>">
			  <input type="hidden" name="<%=linkPageField%>">
			  <input type="hidden" name="<%=linkDisplayField%>">
			  <input type="hidden" name="linkfilename" value="<%=linkFilename%>">
			  <input type="hidden" name="linkrte" value="<%=linkRTE%>">
			  <input type="hidden" name="linkstatus" value="<%=linkStatus%>">
			  <input type="hidden" name="linklevel" value="<%=linkLevel%>">
			  <input type="hidden" name="linkparent"><!-- set from link properties -->
			  <input type="hidden" name="linktarget"><!-- setup() initializes -->
			  <input type="hidden" name="linksortkey" value="<%=linkSortKey%>">
			  <input type="hidden" name="linksectionid" value="<%=linkSectionId%>">
			  <input type="hidden" name="linktosectionid" value="<%=linkToSectionId%>">
			  <input type="hidden" name="other">
			 </div>

<div class="control-group" id="linkdisplay">
	<label class="control-label">
		<span class="linkdisplay">Text Displayed for Link</span>
		<span class="imageLink">Link Displayed as Image</span>
	</label>

	<div class="controls clearfix">
			<div id="linkdisplayImage" class="imageLink"></div>
			<div nowrap="nowrap">
          <input type="text" class="input-block" name="RZtext" onFocus="priorValue=this.value" onBlur="if (priorValue != this.value) changeFilename()" />
          <span onClick="RZspellcheck(document.XMLForm.RZtext)" style="cursor:pointer;" class="help-block small">Spell Check</span>
      </div>
	</div>
</div>

<% if (!linkSeqField.equals("") && rz.fieldtype(listModule,"linkseq") != -1){%>

<div class="control-group">
	<label class="control-label">Link Sequence Number:</label>
	<div class="controls">
		<rz:fetch module="<%=listModule%>" field="<%=linkSeqField%>" options="size=5"/>
		<span class="help-inline">Display order relative to other links</span>
	</div>
</div>

<%}

// new test code for linkimage field
// This should solve the need for special quicklink editlists.
if ( linkoptions.indexOf(",linkimage,") != -1 && rz.isvalidfield(listModule, linkImageField) ) {
%>

<div class="control-group link-image-control">
	<label class="control-label" for="inputEmail">Link Image:
			  <% rz.fetch( listModule, linkImageField,"image,edit"
		        + ",location=" + linkfilelocation
		        + ",extensions=" + linkfileextensions
		        ); %>
	</label>
	<div class="controls">
	    <input type="hidden" name="<%=linkImageField%>" value="<%=rz.fileid%>">
	    <div id="linkdisplayImage" class="imageLink" style="float:none"><%
	    	// if not specfified will need to point to existing image
	    	// if specified, it should be using repo url, so no need to modify
	    	if( rz.src.indexOf("noimage.gif") != -1 ) {
				rz.src = "/revize/images/edit/noimage.gif";
			}
	    	%>
	    	<img name="<%=linkImageField%>_display" src="<%=rz.src%>">
	    </div>
	    <div class="imageOptions">
		    <a href="javaScript:uploadImage()" class="btn btn-default" style="text-decoration:none">
		        Upload
		    </a>
	        <span class="help-block"><small>Current Image displayed above - click on upload to change</small></span>
		</div>
	</div>
</div>

<%}%>

<% if (!isExistingTemplate) {%>
		      <p class="page-header">Select Type of Link from choices below:</p>
<%} else {%>
		      <hr>
		      <div class="alert alert-info">This link created a new page and cannot be changed to another type of link.  To change Delete link and create another.</div>
<%}%>

<% if (linkoptions.indexOf(",none,") != -1 && !isRTE){%>
			  <input type="radio" name="RZlinkType" value="none" onClick="changeType('none')">
				None (link text displayed as heading or placeholder)
<%}%>

<% if (linkoptions.indexOf(",url,") != -1){%>

<div class="control-group">
	<label class="control-label" for="inputEmail">Existing Page <input type="radio" name="RZlinkType" value="url" onClick="changeType('url')"></label>
	<div class="controls">
		<input type="text" class="input-block input-block-with-btn" name="RZurl" size="64" onFocus="RZsetFieldValue(document.XMLForm.RZlinkType,'url');changeType('url')">
		<a href="javaScript:browsePages()" class="btn btn-default" style="text-decoration:none">Browse</a>
	</div>
</div>

<!--
 Existing Page (example
		      <script language="JavaScript" type="text/JavaScript">
				document.write(location.protocol+"//"+location.hostname+"/about.html");
			  </script>)
-->

		  <% if (isRTE && !isTinyMCE) { %>
		  <!-- 04-29-2013
		  <tr>
			<td width="30" valign="middle" height="25">
			  <input type="radio" name="RZlinkType" value="insertanchor"
onClick="changeType('insertanchor')">
			</td>
         	<td valign="middle"><font size="2">
			  Create Bookmark (anchor)
			  <input type="text" name="RZinsertanchor" size="38"
onFocus="RZsetFieldValue(document.XMLForm.RZlinkType,'insertanchor');changeType('insertanchor')">
	          </font>
      		</td>
		  </tr>
		  -->
		  <% } %>
		  <% if (isRTE){ 	//always display dropdown of current bookmarks %>

<div class="control-group">
	<label class="control-label" for="inputEmail">Link to (anchor) <input type="radio" name="RZlinkType" value="createanchor" onClick="changeType('createanchor')"></label>
	<div class="controls">
		<select class="input-block" name="RZcreateanchor" onFocus="RZsetFieldValue(document.XMLForm.RZlinkType,'createanchor');changeType('createanchor')">
			<option value="">--Select Bookmark--</option>
		</select>
	</div>
</div>

		  <%}%>
<%}%>
<% if (linkoptions.indexOf(",file,") != -1){%>

<div class="control-group">
	<label class="control-label" for="inputEmail">Uploaded File:
			  <% rz.fetch( listModule, linkFileField,"file,edit"
		        + ",location=" + linkfilelocation
		        + ",extensions=" + linkfileextensions
		        ); %>
	<input type="radio" name="RZlinkType" value="file" onClick="changeType('file')"></label>
	<div class="controls">
    <input type="hidden" name="<%=linkFileField%>" value="<%=rz.fileid%>">
	  <input name="<%=linkFileField%>_display" type="text" value="<%=rz.filename%>" size="26" readonly="readonly" class="input-block-with-btn">
    <a href="javaScript:uploadFile()" class="btn btn-default" style="text-decoration:none">
        <!--
<img name="<%=linkFileField%>_button"
                src="../images/edit/upload_file.gif" border="0" />
-->Upload</a>
      <span class="help-block"><small>Current selection displayed above - click on upload to change</small></span>
	</div>
</div>

<%}%>
<% if (linkoptions.indexOf(",template,") != -1){%>

	  <p class="page-header">
       <script text="text/javascript">
		if (RZ.editaction == 'create')
		  document.write('Create New')
		else
		  document.write('Update Existing')
	  </script>
	  Page based on design template below:
	  </p>

		<div class="control-group">
			<label class="control-label" for="inputEmail">
		           <script text="text/javascript">
						if (RZ.editaction == 'create')
						  document.write('Create New')
						else
						  document.write('Update Existing')
					  </script>
			<input type="radio" name="RZlinkType" value="template" onClick="changeType('template')"></label>
			<div class="controls">
			  <select id="RZtemplate" class="input-block" name="RZtemplate" onClick="changeType('template')" onFocus="RZsetFieldValue(document.XMLForm.RZlinkType,'template');changeType('template')">
					<option>_____________________</option>
					<option>_____________________</option>
			  </select>
			  <div class="hidden">
				  <span class="help-block"><small>Description of selected design</small></span>
				  <textarea name="RZdescription" wrap="virtual" readonly="true" cols="48" rows="5"></textarea>
			  </div>
			</div>
		</div>
		<div id="selectedarea" class="selectAreaImg"></div>
<%
}//end template fields
%>
	  </form>
<% if(usePathFilename){%>

	  <div id="linkfilenameLayer" style="position: relative;" class="RZhidden">
	    <form action="" method="post" name="linkfilenameForm" class="form-horizontal">
				<div class="control-group">
					<label class="control-label" for="inputEmail">Filename for Page: </label>
					<div class="controls">
						<input name="linkfilename" type="text" size="30" value="<%=linkFilename%>">
					</div>
				</div>
			</form>
        <div id="newSectionPopupLayer" class="RZhidden" style="">
          <div id="newSectionPopup" class="boxed" style="">
          <form action="" method="post" class="clear">
            <div class="right">
            <input name="" type="button" onClick="RZshowlayer('newSectionPopupLayer',false)" value="Close" />
            </div>
            <span id="newsection-parentlinks">
			  Page will have the following top level side navigation links:
              <%--not used on initial 04-29-2013 release
           	  <%@include file="/plugins/menus/menus_head_java_include.jsp"%>
              <%
			  /*BOOKMARK -----newsection popup with parent leftnav links listed*/
			  if (linkoptions.indexOf(",template,") != -1 && rz.isvalidfield(listModule,"linktosectionid"))
              {
	              rz.pagerecordid = rz.pageparentid;
				  revize_menu_linkplacement = "leftnav";
				  %>
                  <span id="">
					<%@ include file="/plugins/menus/menus_leftnav_section_filter_include_code.jsp" %>
					<jsp:include page="/plugins/menus/menus_leftnav_section_list_include.jsp" >
                    <jsp:param name="numberoflevels" value="1" />
                    <jsp:param name="outer_ul_id" value="" />
                    <jsp:param name="outer_ul_class" value="leftnav" />
                    <jsp:param name="inner_ul_used" value="true" />
                    <jsp:param name="filter" value="<%=revize_menu_filter%>" />
                    <jsp:param name="minlevel" value="<%=revize_menu_minlevel%>" />
                    <jsp:param name="debug" value="false" />
					</jsp:include>
                  </span>
				  <%
			  }
			  %>
              --%>
   			</span>
            <span id="newsection-topnav-create" class="RZhidden">
              Top navigation links usually create a new  landing page for
              a group of related pages such as &quot;Departments&quot;, &quot;Boards&quot;, Residents." or Business" which share the same side navigation links.
              <p>
              However if this link is related to the following pages
              (i.e.  shares same side navigation links), Select<strong><em>
              <a href="javascript:">Page has same side navigation links as</a></em></strong>
              </p>
              <ul id="newsection-topnav-relatedlinks">
              	  <%--not used on initial 04-29-2013 release
                  <rz:list
                   module="links" sort="linkseq asc" output="none"
                   options="noscript" filter="<%="linktosectionid="+linkSectionId%>"><%
                  while ( rz.listnext() )
                  {
                      if (rz.listindex < 0) break;
                      %><rz:listbody>
                      <rz:fetch
                      module="links" field="linkdisplay" output="none"
                      options="display,wrap=Virtual"
                      ><li><%=rz.content%></li></rz:fetch><%
                      %></rz:listbody><%
                  }
                  %></rz:list>
              	  --%>
              </ul>
            </span>
            <span id="newsection-leftnav-create" class="RZhidden">
              Side navigation links are usually the same for all related pages such as
              all pages within a department
              <p>
              if this link will NOT have same side navigation links as the following related pages shown below,
              Select <strong><em>
              <a href="">Page starts new side navigation links</a></em></strong>
              </p>
              <ul id="newsection-leftnav-relatedlinks"></ul>
            </span>
          <div id="" class="clear"></div>
          <!-- newsection layer buttons use span to use display:inline not block  -->
            <!-- "more details" button"
            <input name="newSectionDetails" type="button" id="newSectionDetails" value="More Details"
			onClick="newSectionPopup('more')" style="margin-right:20px" />
			-->
		  </form>
          </div>
        </div><!-- end newSectionPopupLayer -->
	  </div>
<%}//end usePathFilename%>
<% if (linkoptions.indexOf(",template,") != -1){%>
	  <!-- legacy div which shows radio buttons and now contains more detailed prompt-->
      <div id="linknewsectionLayer" class="RZhidden" style="position: relative;">
	    <form action="" method="post" name="linknewsectionForm" class="form-horizontal">

			<%
		  	String on = "";
		  	String off = "";
		  	if (rz.editaction.equals("update"))
		  	{
				if (rz.isvalidfield(listModule,"linktosectionid")
				&& linkToSectionId.equals(linkId))
					on = " checked";
				else
					off = " checked";
			}
		  %>
				<div class="control-group">
					<label class="control-label"></label>
					<div class="controls">
        <!-- inline section prompt -->
			      <input type="radio" name="linknewsection" onclick="newSectionPopup('yes')" value="on"<%=on%> disabled /> Page starts new side navigation links
			        <div id="newSectionPopupWarn" class="text-error RZhidden" style="padding-left:18px;display:block">CANNOT change after save</div>
			        <div id="newsection-samelinks">
			          <div class="" id="newsection-showlinks">
			            <a href="javascript:newSectionPopup('more')"></a>
			          </div>
			      <input type="radio" name="linknewsection" id="newSectionNo"onClick="newSectionPopup('no')" value="off"<%=off%> disabled>
							<span id="newsection-home">
						 		Page shows the same side navigation as home page:
							</span>
			          <span id="newsection-parent"> Page shows the same side navigation
			            <div style="padding-left:18px;">
			            links as the parent page:
			            <%
			            rz.linkoptions = "activeurl";
			            LinkManagerData linkManagerData = null;
			            String linkManagerFilter = "";
			            if (StringUtils.toInt(linkParentId) > 0)
			            	  linkManagerFilter = "recordid="+linkParentId;
			            linkManagerData = rz.linkmanager(listModule,linkManagerFilter);
			            //linkManagerData = rz.linkmanager(listModule,linkManagerFilter);
			            String parentPage = "<a href=\"javascript:popup('" + rz.url + "')\" target>"
			  					+ rz.url.replaceAll(" ","&nbsp;") + "</a>";
			            rz.linkoptions = "";
			            %><%= parentPage %>

									<script type="text/javascript">
									function popup(url)
									{
										newSectionPopup('no');
										var sizes = RZscreensizes(0,0);
										var width = Math.min(sizes.screenWidth,1100);
										var height = Math.min(sizes.screenHeight,800) - 100;
										url = '<%=revizeChannelUrl%>/' + url;
										RZpopupUrl('revize_linkmanager',url,width,height,'yes');
									}
									</script>
			            </div>
			          </span>
			      </div>
					</div>
				</div>
		</form>
	  </div>
<%}//end template fields%>
	  <form action="" method="post" name="controlForm" id="controlForm" class="form-horizontal">
			<script language="JavaScript">
			/*--------------------------------------------------------------------------
			Called from hidden link in title; put here so it is easy to set break point
			on linkSelect() function call on input tag below.
			--------------------------------------------------------------------------*/
			function debugMode()
			{
				var linkname = '<%=linkname%>'
				var msg = 'Version: <%=VERSION_LM%>\n'
						+ 'RTE Link Manager linkname (' + linkname + ') properties:\n';
				var value = ''
				for (var i in RZ.parent.RZ.link[linkname])
				{
					msg += '    ' + i + '  =  '
					value = RZ.parent.RZ.link[linkname][i]
					if (i == 'set')
						value = value.split(',').join(',\n                ')
					else if (i.indexOf('url') != -1)
					{
						value = value.split('?').join('\n                    ?')
						value = value.split('&').join('\n                    &')
						value = unescape(value)
					}
					msg += value + '\n'
				}
				if (RZ.repair)
				{
					msg += '\nrepair_page_key=<%=repair_page_key%>\t'
					msg += 'repair_parent_key=<%=repair_parent_key%>'
				}
				msg += "\n msie=" + RZ.browserversion;
				RZdebugger(msg)
			}
			</script>

			<div class="control-group">
				<div class="controls">
				  <input type="button" name="continue" value="Continue" onclick="linkSelect()" class="btn btn-primary">
				  <input type="button" name="cancel" value="Cancel" onclick="linkCancel()" class="btn btn-inverse">
				</div>
			</div>

<!-- Working form fields not saved to module -->
<input type="hidden" name="linkpathname" value="">
<input type="hidden" name="linknewsection" value="">
<input type="hidden" name="linkautocontinue" value="">
<input type="hidden" name="popupwidth">
<input type="hidden" name="popupheight">
<input type="hidden" name="popupscroll">
<input type="hidden" name="nexturl">
<input type="hidden" name="filelocation">
<input type="hidden" name="set">
	  </form>
<script type="text/javascript">

/*---------------------------------------------------------------------------
Put page properties icon on page if page permissions warnings are enabled
----------------------------------------------------------------------------*/
if (RZcheckoptions('<%=rz.permissions_options%>',"warnings")) document.write(
	'<div id="RevizeNote" style="visibility:visible; position:absolute; z-index:1; top:1">',
	'  <a href="javascript:RZpageMessage();"><img border="0"',
	'   src="/revize/images/warning-page.gif" alt="Properties"></a>',
	'</div>',
	'')
/*-----------------------------------------------------------------------------
-----------------------------------------------------------------------------*/
function RZpageMessage()
{

	RZ.message = ''
	RZ.parameters = ''
	var linkname = '<%=linkname%>'
	RZaddUrlParameter('Link Manager Name: ' + linkname )
	RZ.message += '\n'

	if (linkname != '' && RZwinaccess(RZ.parent.opener))
	{
		var win = RZ.parent.opener
		RZ.message += 'Link Manager Properties:\n\n'

		if (RZwinaccess(RZ.parent.opener))
		{
			for (var i in win.RZ.link[linkname])
				RZaddUrlParameter(i + ': ' + win.RZ.link[linkname][i] )
		}
	}

	alert(RZ.message)
}
/*-----------------------------------------------------------------------------
-----------------------------------------------------------------------------*/
</script>
<pre class="stackTrace" style="border:none;background:none;"><%=rz.tracestack%></pre>

<script src="/revize/util/ui/js/jquery-1.10.1.min.js"></script>
<script src="/revize/util/ui/js/bootstrap.min.js"></script>

</body>
</html>