// /**
//  * @author Revize, LLC.
//  *
//  * @copyright Copyright (c) 2009, Revize, LLC, All rights reserved.
//  *
//  * Dave Otto created June 2009 for Revize
//  *
//  * revize_form_wizard plugin modeled after table plugin
//  *
//  */
(function() {
	var each = tinymce.each;

	tinymce.create('tinymce.plugins.RevizeFormsWizard',	{
        getInfo : function()
        {
            return {
				longname : 'Revize Form Wizard',
				author : 'Revize LLC Dave Otto',
				authorurl : 'http://www.revize.com',
				infourl : 'http://www.revize.com',
				version : '3.4.3.197'
            };
		},

		init : function(ed, url)
		{
			var f = this;
			f.editor = ed;
			f.url = url;

			each([
			['formwizard', 'icon_edit_form.gif', 'Insert or Update a Form / Field', 'formwizard', true],
  			['formwizard_delete', 'icon_delete_form.gif', 'Delete Form', 'formwizard_delete']
			], function(c) {
				ed.addButton(c[0], {image : url + '/image/' + c[1], title : c[2], cmd : c[3], ui : c[4]});
			});

			ed.onInit.add(function() {
				if (ed && ed.plugins.contextmenu)
				{
					ed.plugins.contextmenu.onContextMenu.add(function(th, m, e) {
						var sm;
						if (ed.dom.getParent(e, 'form'))
						{
							m.addSeparator();
							if (e.nodeName.toLowerCase() == 'input'
							|| e.nodeName.toLowerCase() == 'select'
							|| e.nodeName.toLowerCase() == 'textarea')
              					m.add({title : 'Update form field', cmd : 'formwizard', ui : true});
							else
							{
								sm = m.addMenu({title : 'Insert form field...'});
								sm.add({title : 'Text Area',    cmd : 'formwizard_text', ui : true});
								sm.add({title : 'Radio Button', cmd : 'formwizard_radio', ui : true});
								sm.add({title : 'Check Box',    cmd : 'formwizard_checkbox', ui : true});
								sm.add({title : 'List Menu',    cmd : 'formwizard_listmenu', ui : true});
								sm.add({title : 'Button',       cmd : 'formwizard_button', ui : true});
							}
							m.add({title : 'Update form properties', cmd : 'formwizard_form', ui : true});
							m.add({title : 'Delete form and fields', cmd : 'formwizard_delete', ui : true});
							m.addSeparator();
						}
						else
							m.add({title : 'Insert form', cmd : 'formwizard', ui : true});
					});
				}
			});	// end ed.onInit.add

			ed.onNodeChange.add(function(ed, cm, n)
			{
				/* always enabled
				var p = ed.dom.getParent(n, 'form');
				if (!p && ed.dom.doc.getElementsByTagName('form').length > 0) {
					cm.setActive('formwizard',0);
					cm.setDisabled('formwizard', 1);
				} else if (!p) {
					cm.setActive('formwizard',0);
					cm.setDisabled('formwizard', 0);
				} else {
					cm.setActive('formwizard',1);
					cm.setDisabled('formwizard', 0);
				}
				*/
			});	// end ed.onNodeChange.add
        },

		execCommand : function(cmd, ui, val)
		{
			var ed = this.editor, b;

			// Is plugin command
			switch (cmd)
			{
				case "formwizard":
					if (!ed.dom.getParent(ed.selection.getNode(), "form")		//not inside form
					&& ed.dom.doc.getElementById('formwizziwmorf'))				//but form exists
					{
						ed.selection.select(ed.dom.select('form')[0])
						//alert('Cursor must be positioned inside form to make changes')
						//return true;
					}
				case 'formwizard_form':
				case 'formwizard_text':
				case 'formwizard_radio':
				case 'formwizard_checkbox':
				case 'formwizard_listmenu':
				case 'formwizard_button':
	  			case "formwizard_delete":
	  				ed.execCommand('mceBeginUndoLevel');
          			this._doExecCommand(cmd, ui, val);
					ed.execCommand('mceEndUndoLevel');
					return true;
			}
			// Not command for this pluging - Pass to next handler in chain
			return false;
		},

		_doExecCommand : function(command, user_interface, value)
		{
			var inst = this.editor, url = this.url;
			var focusElm = inst.selection.getNode();
			var doNotCacheDate = new Date();
			// Handle commands
			switch (command)
			{
  				case "formwizard":
				case 'formwizard_form':
				case 'formwizard_text':
				case 'formwizard_radio':
				case 'formwizard_checkbox':
				case 'formwizard_listmenu':
				case 'formwizard_button':
					inst.windowManager.open({
						url: url + '/html/dlg_formobjects.html?'+doNotCacheDate,
						width: 750,
						height: 500,
						inline: 1
					}, {
						plugin_url: url,
						element: focusElm.nodeName,
						command: command
					});
	  				return true;

				case "formwizard_delete":
					var form = inst.dom.getParent(inst.selection.getNode(), "form");
					if (form) {
						form.parentNode.removeChild(form);
						inst.execCommand('mceRepaint');
					}
					return true;

			}	//end switch

			// Pass to next handler in chain (should not get here since only called with valid cmd)
			return false;

		}	//end _doExecCommand

	});	// end tinymce.create

	// Register plugin
	tinymce.PluginManager.add('revize_form_wizard', tinymce.plugins.RevizeFormsWizard);	//folder,plugin class
})();