/**
 * save/validate functions from formwizard_setvariables.js
 * inline code and general functions such as getfield moved into formwizard.js
 * Hint: format prior file before comparing
 */

function FWinitFormValues(win)	//NEW FUNCTION (functionality was in each html file)
{
	var title = win.document.title;
	var type = RZgetfileinfo(win.location.href).filename;

	if (type != 'fwhelp')
	{
		if (type == 'fwcfb' || type == 'fwhelp')
			title = title;
		else if ((type == 'fwform' && !FW.formElm)
		|| (type != 'fwform' && !FW.update))
			title = 'Creating New ' + title;
		else
		{
			title = 'Update Existing ' + title;
			if (type != 'fwform')
			{
				var name = FW.fieldAttributes.name;
				if (name) title += ' (' + name + ')';
				if (type != FW.fieldType)
				{
					title = 'Change Existing Field';
					if (name) title += ' (' + name + ')';
					title += ' to ' + win.document.title;
				}
			}
		}
	}
	updateTitle(title)

	setfieldvalue("txtValue", FW.fieldAttributes.value);
	switch (type.toLowerCase())
	{
		case 'fwform':
			var rzform = FW.rzform;

			// set all fields, even if not selected type
			setfieldvalue("radTechType",rzform.technology);
			setfieldvalue("successpage",rzform.successpage);
			setfieldvalue("errorpage",rzform.errorpage);
			setfieldvalue("txtemailAdd",rzform.email);
			setfieldvalue("email_from",rzform.from);
			setfieldvalue("email_subject",rzform.subject);
			setfieldvalue("email_cc",rzform.cc);
			setfieldvalue("txtFileName",rzform.filename);
			setfieldvalue("radiobutton",rzform.savemode);
			setfieldvalue("txtFormName",rzform.formName);
			setfieldvalue("hiddenFormId",parent.RZ.pageid);
			break;

		case 'fwcfb': 	//quick builder
			break;

		case 'fwinspection': 	//quick builder
			break;

		case 'fwgeneralrequest': 	//quick builder
			break;
		case 'fwlistmenu':
			setfieldvalue("chkMultipleSelections", FW.fieldAttributes.multiple);
			setfieldvalue("txtSize", FW.fieldAttributes.size);
			if (getfield('valueList'))
			{
				setfieldvalue("txtValue", '');	//field for adding options

				// must populate options using options function
				var valueList = getfield("valueList")
				valueList.selectedIndex = -1;
				for (var opt=0;opt<FW.fieldAttributes.options.length;opt++)
				{
					var selected = (FW.fieldAttributes.selectedIndex == opt);
					var value = FW.fieldAttributes.options[opt];
					valueList.options[opt] = new Option(
												FW.fieldAttributes.options[opt].text,
												FW.fieldAttributes.options[opt].value,
												selected, selected);
				}
				FWchoiceDefaultSelectedList(valueList.selectedIndex);
			}
			//fall through for remaining field initialization

		case 'fwbutton':
			setfieldvalue("optAction", FW.fieldAttributes.action);

		// shared for all fields (nothing happens if form field
		// or FW.fieldAttributes is undefined)
		default:
			setfieldvalue("optType", FW.fieldAttributes.texttype);
			setfieldvalue("txtName", FW.fieldAttributes.name);
			if (FW.fieldAttributes.maxlength
			&& !isNaN(FW.fieldAttributes.maxlength)
			&& FW.fieldAttributes.maxlength > 10000)
				FW.fieldAttributes.maxlength = '';
			setfieldvalue("txtLength", FW.fieldAttributes.maxlength, 40);
			setfieldvalue("chkChecked", FW.fieldAttributes.checked);
			setfieldvalue("chkRequired", FW.fieldAttributes.required);
			setfieldvalue("chkMultipleFilesUpload", FW.fieldAttributes.multiple);
			setfieldvalue("txtRows", FW.fieldAttributes.rows, 1);
			setfieldvalue("txtColumns", FW.fieldAttributes.cols, 20);
			setfieldvalue("wrap", FW.fieldAttributes.wrap);

			if (getfield("txtName"))
				getfield("txtName").focus();
	}
	if (win.setDisabled)	//if disable function, call it
		win.setDisabled();

	if (getfield('msg'))
	{
		getfield('msg').style.visibility = 'visible';
		FWdisplayMessage('');	//focus does not work here
	}
}

/*------------------------------------------------------------------------------
 function setting the values of variables - was called RZsetvalues()
 at the time of form-unload, this is useful in case of editting
 and on the press of OK on any control window.
 On the basis of variables set appropriate html string is formed
 ------------------------------------------------------------------------------*/
function FWsaveFormValues(str)
{
	if (str == "FWform")
	{
		// These properties are stored in inst.FW.rzform (not html)
		var rzform = FW.rzform;
		rzform.savemode = getfieldvalue("radiobutton");
		rzform.technology = 'JSP';	//getfieldvalue("radTechType");
		rzform.successpage = getfieldvalue("successpage");
		rzform.errorpage = getfieldvalue("errorpage");

		rzform.filename = getfieldvalue("txtFileName");

		rzform.email = getfieldvalue("txtemailAdd").replace(/,/g,';');
		rzform.from = getfieldvalue("email_from").replace(/,/g,';');
		rzform.subject = getfieldvalue("email_subject");
		rzform.cc = getfieldvalue("email_cc").replace(/,/g,';');
		//added new field to capture formname provided by user
		rzform.formName = getfieldvalue("txtFormName");
		rzform.formId = getfieldvalue("hiddenFormId");

		if (!rzform.savemode)
		{
			if (rzform.filename == '' && rzform.email != '')
				rzform.savemode = 'email';
			else if (rzform.filename != '' && rzform.email == '')
				rzform.savemode = 'ftp';
		}
		return;
	}

	//------MINDFIRE For CFB : start-----------------
	else if (str == "FWCFB")
	{
		FW.tagName = '';
		FW.quickbuilder = {checked:[], caption:[], fieldname:[] };

		FW.quickbuilder.caption[0] = getfield("textfield0").value;
		FW.quickbuilder.caption[1] = getfield("textfield1").value;
		FW.quickbuilder.caption[2] = getfield("textfield2").value;
		FW.quickbuilder.caption[3] = getfield("textfield3").value;
		FW.quickbuilder.caption[4] = getfield("textfield4").value;
		FW.quickbuilder.caption[5] = getfield("textfield5").value;
		FW.quickbuilder.caption[6] = getfield("textfield6").value;
		FW.quickbuilder.caption[7] = getfield("textfield7").value;
		FW.quickbuilder.caption[8] = getfield("textfield8").value;
		FW.quickbuilder.caption[9] = getfield("textfield9").value;
		FW.quickbuilder.caption[10] = getfield("textfield31").value;//Attachment label
		FW.quickbuilder.caption[11] = getfield("textfield10").value; //Comments
		
		FW.quickbuilder.fieldname[0] = getfield("textfield11").value;
		FW.quickbuilder.fieldname[1] = getfield("textfield12").value;
		FW.quickbuilder.fieldname[2] = getfield("textfield13").value;
		FW.quickbuilder.fieldname[3] = getfield("textfield14").value;
		FW.quickbuilder.fieldname[4] = getfield("textfield15").value;
		FW.quickbuilder.fieldname[5] = getfield("textfield16").value;
		FW.quickbuilder.fieldname[6] = getfield("textfield17").value;
		FW.quickbuilder.fieldname[7] = getfield("textfield18").value;
		FW.quickbuilder.fieldname[8] = getfield("textfield19").value;
		FW.quickbuilder.fieldname[9] = getfield("textfield20").value;
		FW.quickbuilder.fieldname[10] = getfield("textfield32").value;//Attachment field name
		FW.quickbuilder.fieldname[11] = getfield("textfield21").value; //Comments

		FW.quickbuilder.checked[0] = getfield("checkbox0").checked;
		FW.quickbuilder.checked[1] = getfield("checkbox1").checked;
		FW.quickbuilder.checked[2] = getfield("checkbox2").checked;
		FW.quickbuilder.checked[3] = getfield("checkbox3").checked;
		FW.quickbuilder.checked[4] = getfield("checkbox4").checked;
		FW.quickbuilder.checked[5] = getfield("checkbox5").checked;
		FW.quickbuilder.checked[6] = getfield("checkbox6").checked;
		FW.quickbuilder.checked[7] = getfield("checkbox7").checked;
		FW.quickbuilder.checked[8] = getfield("checkbox8").checked;
		FW.quickbuilder.checked[9] = getfield("checkbox9").checked;
		FW.quickbuilder.checked[10] = getfield("checkbox30").checked;//Add File
		FW.quickbuilder.checked[11] = getfield("checkbox10").checked; //Comments
		FW.quickbuilder.checked[12] = getfield("checkbox33").checked;//isMultiple
		FW.quickbuilder.checked[13] = getfield("checkbox11").checked; //Add Table		
		return;
	}
	//-----MINDFIRE For CFB : finish-----------------

	//------MINDFIRE For FWInspection : start-----------------
		else if (str == "FWInspection")
		{
			FW.tagName = '';
			FW.quickbuilder = {checked:[], caption:[], fieldname:[] };

			FW.quickbuilder.caption[0] = getfield("textfield0").value;
			FW.quickbuilder.caption[1] = getfield("textfield1").value;
			FW.quickbuilder.caption[2] = getfield("textfield2").value;
			FW.quickbuilder.caption[3] = getfield("textfield3").value;
			FW.quickbuilder.caption[4] = getfield("textfield4").value;
			FW.quickbuilder.caption[5] = getfield("textfield5").value;
			FW.quickbuilder.caption[6] = getfield("textfield6").value;


			FW.quickbuilder.fieldname[0] = getfield("textfield7").value;
			FW.quickbuilder.fieldname[1] = getfield("textfield8").value;
			FW.quickbuilder.fieldname[2] = getfield("textfield9").value;
			FW.quickbuilder.fieldname[3] = getfield("textfield10").value;
			FW.quickbuilder.fieldname[4] = getfield("textfield11").value;
			FW.quickbuilder.fieldname[5] = getfield("textfield12").value;
			FW.quickbuilder.fieldname[6] = getfield("textfield13").value;

			FW.quickbuilder.checked[0] = getfield("checkbox0").checked;
			FW.quickbuilder.checked[1] = getfield("checkbox1").checked;
			FW.quickbuilder.checked[2] = getfield("checkbox2").checked;
			FW.quickbuilder.checked[3] = getfield("checkbox3").checked;
			FW.quickbuilder.checked[4] = getfield("checkbox4").checked;
			FW.quickbuilder.checked[5] = getfield("checkbox5").checked;
			FW.quickbuilder.checked[6] = getfield("checkbox6").checked;
			FW.quickbuilder.checked[7] = getfield("checkbox7").checked;

			return;
		}

		else if (str == "FWGeneralRequest")
		{
			FW.tagName = '';
			FW.quickbuilder = {checked:[], caption:[], fieldname:[] };

			FW.quickbuilder.caption[0] = getfield("textfield0").value;
			FW.quickbuilder.caption[1] = getfield("textfield1").value;
			FW.quickbuilder.caption[2] = getfield("textfield2").value;
			FW.quickbuilder.caption[3] = getfield("textfield3").value;
			FW.quickbuilder.caption[4] = getfield("textfield4").value;
			FW.quickbuilder.caption[5] = getfield("textfield5").value;
			FW.quickbuilder.caption[6] = getfield("textfield6").value;
			FW.quickbuilder.caption[7] = getfield("textfield7").value;
			FW.quickbuilder.caption[8] = getfield("textfield8").value;


			FW.quickbuilder.fieldname[0] = getfield("textfield9").value;
			FW.quickbuilder.fieldname[1] = getfield("textfield10").value;
			FW.quickbuilder.fieldname[2] = getfield("textfield11").value;
			FW.quickbuilder.fieldname[3] = getfield("textfield12").value;
			FW.quickbuilder.fieldname[4] = getfield("textfield13").value;
			FW.quickbuilder.fieldname[5] = getfield("textfield14").value;
			FW.quickbuilder.fieldname[6] = getfield("textfield15").value;
			FW.quickbuilder.fieldname[7] = getfield("textfield16").value;
			FW.quickbuilder.fieldname[8] = getfield("textfield17").value;

			FW.quickbuilder.checked[0] = getfield("checkbox0").checked;
			FW.quickbuilder.checked[1] = getfield("checkbox1").checked;
			FW.quickbuilder.checked[2] = getfield("checkbox2").checked;
			FW.quickbuilder.checked[3] = getfield("checkbox3").checked;
			FW.quickbuilder.checked[4] = getfield("checkbox4").checked;
			FW.quickbuilder.checked[5] = getfield("checkbox5").checked;
			FW.quickbuilder.checked[6] = getfield("checkbox6").checked;
			FW.quickbuilder.checked[7] = getfield("checkbox7").checked;
			FW.quickbuilder.checked[8] = getfield("checkbox8").checked;
			FW.quickbuilder.checked[9] = getfield("checkbox9").checked;

			return;
		}
	//-----MINDFIRE For CFB : finish-----------------

	else
	{
		FW.tagName = 'input';		//most fields use input tag
		FW.fieldAttributes.type = '';
		saveAttributes({name: 'txtName'});
		switch (str)
		{
			case "FWtextfield":
				saveAttributes({
					texttype: 'optType',
					maxlength: 'txtLength',
					rows: 'txtRows',
					cols: 'txtColumns',
					wrap: 'wrap',
					value: 'txtValue'
				});
				switch (FW.fieldAttributes.texttype)
				{
					case 'textfield':
						FW.tagName = 'textarea';
						if (!FW.fieldAttributes.style)
							FW.fieldAttributes.style = 'overflow: hidden';
						break;
					case 'date':
					case 'numeric':
					case 'decimal':
						FW.fieldAttributes.type = 'text';
						break;
					case 'password':
						FW.fieldAttributes.type = 'password';
						break;
					case 'hiddenfield':
						FW.fieldAttributes.type = 'hidden';
						break;
				}
				break;

			case "FWradio":
				FW.fieldAttributes.type = 'radio';
				saveAttributes({checked: 'chkChecked',value: 'txtValue'});
				break;

			case "FWcheckbox":
				FW.fieldAttributes.type = 'checkbox';
				saveAttributes({checked: 'chkChecked',value: 'txtValue'});
				break;

			case "FWbutton":
				saveAttributes({type: 'optAction',value: 'txtValue'});
				break;

			case "FWlistmenu":
				saveAttributes({multiple: 'chkMultipleSelections', size: 'txtSize'});

				var valueList = getfield("valueList")
				var html = valueList.innerHTML.replace(/<(\/?)OPTION/g,'<$1option');	//>
				FW.fieldAttributes.optionsHTML = html;
				FW.fieldAttributes.options = valueList.options;
				FW.fieldAttributes.selectedIndex = getfield("defaultSelectedList").selectedIndex;
				FW.tagName = 'select';
				break;
				
			case "FWfattachment":
				FW.fieldAttributes.type = 'file';
				saveAttributes({multiple: 'chkMultipleFilesUpload'});
				break;
		}
		saveAttributes({required: 'chkRequired'});
		
		
		if (FW.fieldAttributes.required == 'true'|| FW.fieldAttributes.required == true) {
			FW.fieldAttributes.required = 'true';
		} else {
			FW.fieldAttributes.required = '';
		}
		
		if (!FW.fieldAttributes.checked)
			FW.fieldAttributes.checked = '';
		

		if (FW.fieldAttributes.multiple == 'true' || FW.fieldAttributes.multiple == true)
			FW.fieldAttributes.multiple = 'true';
		else 
			FW.fieldAttributes.multiple = '';
	}
}
/**
 * Move input fields from to FW.fieldAttributes
 * @param {Object} attrList List of values containing form id or name
 */
function saveAttributes(attrList)
{
	for (var attr in attrList)
	{
		FW.fieldAttributes[attr] = getfieldvalue(attrList[attr])
	}
}

// function is called if form is opened for editing
// it sets the variables from the input values to the window(dialogArguments)
// and return the name of respective window to be opened in div o fthe main form window
function FWforEditSetVariables(){}	//DELETED

/*------------------------------------------------------------------------------
 Validate fields: id from the Ok input tag which by convention is the filename of
 of the iframe src. Returns true is all is ok otherwise alert and return false.
 Code pretty much transfered as is from formwizard_setvariables.js
 ------------------------------------------------------------------------------*/
function FWvalidate(id)
{
	var rzform = FW.rzform;
	//if (id == "FWInspection" || "FWGeneralRequest" )
	//commented the above line and corrected as below
	if ((id == "FWInspection") || (id == "FWGeneralRequest" ))
	{
		return true;
	}

	if (id == "FWCFB")
	{
		var countj,field;
		for (countj = 0; countj < 11; countj = countj + 1)
		{
            if (FW.quickbuilder.checked[countj])
            {
            	if (!RZtrim(FW.quickbuilder.caption[countj]))
            	{
            		alert("Can not leave a checked field caption blank")
            		field = getfield('textfield' + countj);
            		if (field) field.focus();
					return false;
            	}
            	if (!RZtrim(FW.quickbuilder.fieldname[countj]))
            	{
            		alert("Can not leave a checked field name blank")
            		field = getfield('textfield' + (countj+10));
            		if (field) field.focus();
					return false;
            	}
            }
		}
		return true;
	}
	//----MINDFIRE For CFB : finish-------------------

	if (id == "FWform")
	{
		//----- validation for ftp option
		if (rzform.savemode == 'ftp')
		{
			if (!rzform.filename)
				return alertField("txtFileName","Please Enter File Location");

			if (!RZchkSlashes(rzform.filename))
				return alertField("txtFileName","Incorrect File Format");

			if (!RZchkInvalidChar(rzform.filename))
				return alertField("txtFileName","Filename Contains Invalid Characters");
		}	// end of ftp validation

		//----- email option is selected
		else if (rzform.savemode == 'email')
		{
			if (!rzform.formName)
				return alertField("txtFormName","Form Name is a required field");
			
			if (!emailCheck("txtemailAdd",rzform.email))
				return;

			if (!emailCheck("email_from",rzform.from))
				return;

			if (rzform.email == rzform.from)
				return alertField("email_from","email TO and FROM must different");

			if (!rzform.subject)
				return alertField("email_subject","Email Subject is a required field");

			if (rzform.cc)
			{
				if (!emailCheck("email_cc",rzform.cc))
					return;
			}
		}
		else	//no savemode selected
		{
			return alertField('','Must select how form data will be submitted')
		}
		return true;
	}

	//***** below if validation for fields *****
	getfield("txtName").value = RZtrim(getfield("txtName").value);
	if (getfield("txtName").value.length == 0)
	{
		alert("Please Enter Field Name");
		getfield("txtName").focus();
		return false;
	}

	if (id == "FWbutton")
	{
		getfield("txtValue").value = RZtrim(getfield("txtValue").value);
		if (getfield("txtValue").value.length == 0)
		{
			alert("Please Enter Button Caption");
			getfield("txtValue").focus();
			return false;
		}
	}
	else if (id == "FWlistmenu")
	{
		getfield("txtSize").value = RZtrim(getfield("txtSize").value);
		if (getfield("txtSize").value.length == 0)
		{
			alert("Please Enter Height");
			getfield("txtSize").focus();
			return false;
		}
		else if (false == RZisNumeric(getfield("txtSize").value))
		{
			alert("Height Should Have Numeric Value");
			getfield("txtSize").value = "";
			getfield("txtSize").focus();
			return false;
		}
	}
	else if (id == "FWcheckbox" || id == "FWradio")
	{
		getfield("txtValue").value = RZtrim(getfield("txtValue").value);
		if (getfield("txtValue").value.length == 0)
		{
			alert("Please Enter Submitted Value");
			getfield("txtValue").focus();
			return false;
		}
	}
	else if (id == "FWtextfield")
	{
		getfield("txtValue").value = RZtrim(getfield("txtValue").value);
		if (getfield("optType").value == "date")
		{
			if (RZcheckdate(getfield("txtValue")) == null)
				return false;
		}
		else if (getfield("optType").value == "numeric")
		{
			if (getfield("txtValue").value.length > 0 && false == RZisNumeric(getfield("txtValue").value))
			{
				alert("Please Enter Numeric Value");
				getfield("txtValue").value = "";
				getfield("txtValue").focus();
				return false;
			}
		}
		else if (getfield("optType").value == "decimal")
		{
			if (getfield("txtValue").value.length > 0 && false == RZisDecimal(getfield("txtValue").value))
			{
				alert("Please Enter Decimal Value");
				getfield("txtValue").value = "";
				getfield("txtValue").focus();
				return false;
			}
		}
		if (getfield("txtColumns").disabled == false)
		{
			getfield("txtColumns").value = RZtrim(getfield("txtColumns").value);
			if (getfield("txtColumns").value.length == 0)
			{
				alert("Please Enter Width");
				getfield("txtColumns").focus();
				return false;
			}
			else if (false == RZisNumeric(getfield("txtColumns").value))
			{
				alert("Width Should Be A Numeric Value");
				getfield("txtColumns").value = "";
				getfield("txtColumns").focus();
				return false;
			}
		}
		if (getfield("txtRows").disabled == false)
		{
			getfield("txtRows").value = RZtrim(getfield("txtRows").value);
			if (getfield("txtRows").value.length == 0)
			{
				alert("Please Enter Height");
				getfield("txtRows").focus();
				return false;
			}
			else if (false == RZisNumeric(getfield("txtRows").value))
			{
				alert("Height Should Be A Numeric Value");
				getfield("txtRows").value = "";
				getfield("txtRows").focus();
				return false;
			}
		}
		if (getfield("txtLength").disabled == false)
		{
			getfield("txtLength").value = RZtrim(getfield("txtLength").value);
			if (getfield("txtLength").value.length == 0)
			{
				alert("Please Enter Max Width");
				getfield("txtLength").focus();
				return false;
			}
			else if (false == RZisNumeric(getfield("txtLength").value))
			{
				alert("Max Width Should Be A Numeric Value");
				getfield("txtLength").value = "";
				getfield("txtLength").focus();
				return false;
			}
		}
	}
	return true;
}

/*----method for validating email address---*/
function emailCheck(fieldname,emailStr)
{
	if (!emailStr)
		return alertField(fieldname,"Email address is required");

	/* The following pattern is used to check if the entered e-mail address
	 fits the user@domain format.  It also is used to separate the username
	 from the domain. */
	var emailPat = /^(.+)@(.+)$/
	/* The following string represents the pattern for matching all special
	 characters.  We don't want to allow special characters in the address.
	 These characters include ( ) < > @ , ; : \ " . [ ]    */
	var specialChars = "\\(\\)<>@,;:\\\\\\\"\\.\\[\\]"
	/* The following string represents the range of characters allowed in a
	 username or domainname.  It really states which chars aren't allowed. */
	var validChars = "\[^\\s" + specialChars + "\]"
	/* The following pattern applies if the "user" is a quoted string (in
	 which case, there are no rules about which characters are allowed
	 and which aren't; anything goes).  E.g. "jiminy cricket"@disney.com
	 is a legal e-mail address. */
	var quotedUser = "(\"[^\"]*\")"
	/* The following pattern applies for domains that are IP addresses,
	 rather than symbolic names.  E.g. joe@[123.124.233.4] is a legal
	 e-mail address. NOTE: The square brackets are required. */
	var ipDomainPat = /^\[(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})\]$/
	/* The following string represents an atom (basically a series of
	 non-special characters.) */
	var atom = validChars + '+'
	/* The following string represents one word in the typical username.
	 For example, in john.doe@somewhere.com, john and doe are words.
	 Basically, a word is either an atom or quoted string. */
	var word = "(" + atom + "|" + quotedUser + ")"
	// The following pattern describes the structure of the user
	var userPat = new RegExp("^" + word + "(\\." + word + ")*$")
	/* The following pattern describes the structure of a normal symbolic
	 domain, as opposed to ipDomainPat, shown above. */
	var domainPat = new RegExp("^" + atom + "(\\." + atom + ")*$")


	/* Finally, let's start trying to figure out if the supplied address(s) are valid. */
	var emailArray = emailStr.split(';');
	for (var emailIdx=0;emailIdx<emailArray.length;emailIdx++)
	{
		emailStr = emailArray[emailIdx];

		/* Begin with the coarse pattern to simply break up user@domain into
		 different pieces that are easy to analyze. */
		var matchArray = emailStr.match(emailPat)
		if (matchArray == null)
		{
			/* Too many/few @'s or something; basically, this address doesn't
			 even fit the general mould of a valid e-mail address. */
			alertField(fieldname,"Email address seems incorrect (check @ and .'s)")
			return false
		}
		var user = matchArray[1]
		var domain = matchArray[2]

		// See if "user" is valid
		if (user.match(userPat) == null)
		{
			// user is not valid
			alertField(fieldname,"The username doesn't seem to be valid.")
			return false
		}

		/* if the e-mail address is at an IP address (as opposed to a symbolic
		 host name) make sure the IP address is valid. */
		var IPArray = domain.match(ipDomainPat)
		if (IPArray != null)
		{
			// this is an IP address
			for (var i = 1; i <= 4; i++)
			{
				if (IPArray[i] > 255)
				{
					alertField(fieldname,"Destination IP address is invalid!")
					return false
				}
			}
			return true
		}

		// Domain is symbolic name
		var domainArray = domain.match(domainPat)
		if (domainArray == null)
		{
			alertField(fieldname,"The domain name doesn't seem to be valid.")
			return false
		}

		/* domain name seems valid, but now make sure that it ends in a
		 three-letter word (like com, edu, gov) or a two-letter word,
		 representing country (uk, nl), and that there's a hostname preceding
		 the domain or country. */
		/* Now we need to break up the domain to get a count of how many atoms
		 it consists of. */
		var atomPat = new RegExp(atom, "g")
		var domArr = domain.match(atomPat)
		var len = domArr.length
		if (domArr[domArr.length - 1].length < 2 ||
		domArr[domArr.length - 1].length > 4)
		{
			// the address must end in a two letter or three letter word.
			alertField(fieldname,"The address must end in a three-letter domain, or two letter country.")
			return false
		}

		// Make sure there's a host name preceding the domain.
		if (len < 2)
		{
			var errStr = "This address is missing a hostname!"
			alertField(fieldname,errStr)
			return false
		}
	}

	// If we've gotten this far, everything's valid!
	return true;
}
/*------------------------------------------------------------------------------
Display alert with msg then if fieldname is specified and found, give focus and
select it it permitted for the type of field.
Always return false;
------------------------------------------------------------------------------*/
function alertField(fieldname,msg)
{
	alert(msg);
	if (fieldname)
	{
		var field = getfield(fieldname);
		if (field)
		{
			if (field.focus) field.focus();
			if (field.select) field.select();
		}
	}
	return false;
}
