/**
 * @author Revize, LLC.
 * @copyright Copyright � 2008, Revize, LLC, All rights reserved.
 *
 * Dave Otto created April 2007 for Revize
 * Modified/migrated by Nicholas J. Michalek, 2008-05-07
 *
 * Slightly modified version of advImage plugin
 * (still uses advImage language pack)
 *
 *
 */

 (function(){
	RZ.tinymce.modal = { opener : null, frame : null, dialog : null };
 })();
 
tinyMCE.PluginManager.add('RevizeImageManager', function(editor, url) {
	var openDialog = function () {
		if (ed.dom.getAttrib(ed.selection.getNode(), 'class').indexOf('mceItem') != -1)
		return;

		RZ.image.ed = ed;
		RZ.image.template = RZtinymceToImageManager(ed);
		RZ.image.template.inline = 0;	//inline nogo for frameset
		RZ.image.options = { plugin_url : url };

		ed.windowManager.open(RZ.image.template, RZ.image.options);
	};
  
	// Add a button that opens a window
	editor.ui.registry.addButton('rzImage', {
	  icon: 'image',
	  onAction: function () {
		// Open window
		editor.targetElm.linktemplate = "";
		editor.editorId = editor.targetElm.id;
		openDialog();
	  },
	  onSetup: function (api) {
		  /*editor.on("nodechange", function(el) { // Disable Button if nothing selected.
			  api.setDisabled(el.element.nodeName != 'A' && el.element.name);
		  });*/
	  }
	});
  
	// Adds a menu item, which can then be included in any menu via the menu/menubar configuration
	editor.ui.registry.addMenuItem('examplec', {
	  text: 'Example plugin',
	  onAction: function() {
		// Open window
		openDialog();
	  }
	});

	return {
		getMetadata: function () {
		  return  {
			longname : 'Revize Image Manager',
			author : 'Revize LLC (Dave Otto, Nicholas J. Michalek)',
			authorurl : 'http://www.revize.com/',
			infourl : 'http://wiki.moxiecode.com/index.php/TinyMCE:Plugins/advimage',
			version : "3.0.8.187"
		  };
		}
	  };
});

// (function() {
// 	tinymce.create('tinymce.plugins.RevizeImageManager',
// 	{
// 		/**
// 		 * Initializes the plugin, this will be executed after the plugin has been created.
// 		 * This call is done before the editor instance has finished it's initialization so use the onInit event
// 		 * of the editor instance to intercept that event.
// 		 *
// 		 * @param {tinymce.Editor} ed Editor instance that the plugin is initialized in.
// 		 * @param {string} url Absolute URL to where the plugin is located.
// 		 */
// 		init : function(ed, url)
// 		{
			
// 			// 2/19/2020 - Handle Multiple TinyMCEs
// 			RZ.tinymce.modal = { opener : null, frame : null, dialog : null };
			
// 			// Register commands
// 			ed.addCommand('rzImage', function() {
// 				// Internal image object like a flash placeholder
// 				if (ed.dom.getAttrib(ed.selection.getNode(), 'class').indexOf('mceItem') != -1)
// 					return;

// 				RZtinymceToImageManager(ed,url);
// 			});

// 			// Register buttons
// 			ed.ui.registry.addButton('image', {
// 				title : 'advimage.image_desc',
// 				cmd : 'rzImage'
// 			});
// 		},


// 		/**
// 		 * Returns information about the plugin as a name/value array.
// 		 * The current keys are longname, author, authorurl, infourl and version.
// 		 *
// 		 * @return {Object} Name/value array containing information about the plugin.
// 		 */
// 		getInfo : function()
// 		{
// 			return {
// 				longname : 'Revize Image Manager',
// 				author : 'Revize LLC (Dave Otto, Nicholas J. Michalek)',
// 				authorurl : 'http://www.revize.com/',
// 				infourl : 'http://wiki.moxiecode.com/index.php/TinyMCE:Plugins/advimage',
// 				version : "3.0.8.187"
// 			};
// 		}
// 	});

// 	// Register plugin
// 	tinymce.PluginManager.add('revize_image_manager', tinymce.plugins.RevizeImageManager);
// })();




function RZtinymceToImageManager(inst,url)
{
	if(!(RZ.MSIE && RZ.browserversion < 10)) {

		if(RZ.webspacedesc.indexOf('webgen') == -1) { //for all premium customer (who doesn't have webgen in webspace desc) show new
			RZtinymceToImageManager_new(inst,url);
		} else {
			RZtinymceToImageManager_old(inst,url);
		}
	} else {
		RZtinymceToImageManager_old(inst,url);
	}
}

/*------------------------------------------------------------------------------
Setup tinyMCE Image Manager call for new or existing image
RZ.image is collection of image fields (RZ.image.rte used for rte)
------------------------------------------------------------------------------*/
function RZtinymceToImageManager_new(inst,url)
{
	RZ.image.ed = inst;
	RZ.image.options = { plugin_url : url };
	var selectedImageNode = inst.selection.getNode();   //currently selected image
	if (selectedImageNode.nodeName != 'IMG') {
		RZ.rte.object = '';
	} else {
		RZ.rte.object = selectedImageNode;
	}
	//Kept it for backward compatibility
	var url = '/revize/util/tiny_mce.5.1.2/imagemanager/imagemgr.jsp?webSpaceName=' + encodeURIComponent(RZ.webspace)
	url=url+'&fileLocation='+encodeURIComponent(inst.settings.imagelocation);
	url=url+'&selectedImgPath='+selectedImageNode.src;
	url=url+'&selectedImgDesc='+encodeURIComponent(selectedImageNode.alt);
	url=url+'&selectedImgBorder='+encodeURIComponent(selectedImageNode.border);
	url=url+'&selectedImgHSpace='+encodeURIComponent(selectedImageNode.hspace);
	url=url+'&selectedImgVSpace='+encodeURIComponent(selectedImageNode.vspace);
	url=url+'&selectedImgWidth='+encodeURIComponent(selectedImageNode.width);
	url=url+'&selectedImgHeight='+encodeURIComponent(selectedImageNode.height);
	url=url+'&selectedImgAlign='+encodeURIComponent(selectedImageNode.align);

	var winOptions = new Object();
	// winOptions.windowname='SelectImage';
	// winOptions.url=url;
	// winOptions.width='960';
	// winOptions.height='600';

	// properties used to open new window (used by RZtinymceReloadImageManager)
	// var newWinProp = new Object();
	// newWinProp.title   = RZ.tinymce.popupWindowName;
	// newWinProp.body    = {};
	// newWinProp.buttons    = [];
	// newWinProp.name    = RZ.tinymce.popupWindowName;
	// newWinProp.file    = url;
	// newWinProp.width   = parseInt(winOptions.width);
	// newWinProp.height  = parseInt(winOptions.height)+15;	//leave room for status message
	// newWinProp.inline = 0;
	// newWinProp.scrollbars=true;
	// var newWinOptions = { plugin_url : url };

	//do not exceed screen size -- chrome requires window.moveBy(0,0)
	/* think tinymce does this -- just need window.moveBy(0,0) in IM onload
	if (screen.availWidth <= newWinProp.width)
		newWinProp.width = screen.width;
	if (screen.availHeight <= newWinProp.height)
		newWinProp.height = screen.height;
	*/

	RZ.tinymce.modal.dialog = inst.windowManager.openUrl({
			title : 'Image Manager',
			url: url,
			inline : 0,
			RZ: RZ
	});
	//RZ.tinymce.modal.dialog.block("Loading");
}
function RZtinymceToImageManager_old(inst,url)
{
	RZ.rte.object = inst.selection.getNode();   //currently selected image
	if (RZ.rte.object.nodeName != 'IMG')
		RZ.rte.object = '';

	// pseudo image value form field (may be referenced indirectly)
	var image_value = new Object();
	image_value.name = 'rte';
	image_value.value = '0';			//should be the noimage fileid

	// pseudo display image form field (may be referenced indirectly)
	var image_display = new Object();
	image_display.name = 'image_display';

	// url contains most of these options
	RZsetImageManagerProperties( 'image',
								inst.settings.imagelocation,
								inst.settings.extension,
	                            image_display.name,
	                            image_value.name,
	                            image_value.value,
								inst.settings.imagemaxwidth,
								inst.settings.imagemaxheight,
								inst.settings.imagemaxbytes,
								inst.settings.brief);

	RZ.image.isRTE = true;		//indicates rte call
	RZ.image.complete = false;	//prevent from thinking reload call
	RZ.image.ed = inst;

	// properties used to open new window (used by RZtinymceReloadImageManager)
	RZ.image.template = new Object();
	RZ.image.template.name    = RZ.tinymce.popupWindowName;
	RZ.image.template.file    = RZ.image.rte.url + '&rte=tinymce';
	RZ.image.template.width   = parseInt(RZ.image.rte.width) + 10;
	RZ.image.template.height  = parseInt(RZ.image.rte.height) + 75;
	RZ.image.template.inline = 0;	//inline nogo for frameset
	RZ.image.options = { plugin_url : url };
	inst.windowManager.open(RZ.image.template, RZ.image.options);
}
/*------------------------------------------------------------------------------
Reload image manager after servlet call
TODO: this code should be moved to revize_image_manager/editor_plugin.js
------------------------------------------------------------------------------*/
function RZtinymceReloadImageManager(search)
{
	//following data saved by revize_image_manager plugin
	var ed = RZ.image.ed;				//editor instance
	var template = RZ.image.template;
	var options = RZ.image.options;

	template.file = '/revize/util/tiny_mce.5.1.2/image_frame.jsp' + search;


	ed.windowManager.open(template, options);
}
/*---------------------------------------------------------------------------
Setup tinyMCE Link Manager call for new or existing link
TODO: this code should be moved to revize_link_manager/editor_plugin.js
------------------------------------------------------------------------------*/
function RZtinymceToLinkManager(inst, parentLink, plugin_url)
{
	var id = ''
	var module = ''
	var linkType = 'new'
	var linktemplate = '';
	var template = 'templatename=';
	var urlModule = 'urlmodule=';
	var urlrecord = 'urlrecord=';
	var fileAttr = '';
	var hrefAttr = '';
	var linktosectionid = '';

	var field = document.getElementById(inst.id);
	var linkname = inst.getElement().linkname;
	var focusElm = inst.selection.getNode();

	//TODO: where is this used?
	if (focusElm.nodeName == "IMG") RZ.rte.selectedImage = focusElm;

	RZ.link[linkname].linkurldefault = '';
	RZ.link[linkname].linkdisplaydefault = '';
	RZ.link[linkname].linkfiledefault = '';

	console.log('field');
	console.log(field);
	console.log('editor ID');
	console.log(inst.id);
	if (field.linktemplate)
		linktemplate = '&linktemplate=' + field.linktemplate;

	// build list of bookmarks
	if (inst.getContent().match(RZ.tinymce.bookmarkList) != -1)
	{
		RZ.link[linkname].linkbookmarks = [];
		RZ.tinymce.patternBookmarkList = /<a[\s\S]*?name="([^"]*)"[\s\S]*?>/gi; //"

		inst.getContent().replace(RZ.tinymce.patternBookmarkList, function(a,b) {
			RZ.link[linkname].linkbookmarks[RZ.link[linkname].linkbookmarks.length] = b;
		})
	}

	//DCO 09-23-2014: too confusing -- let operation fail and report
	//DEBUG:
	//if (focusElm == null) alert("RZtinymceToLinkManager: assertion failed: focusElm != null");

	//----- EXISTING LINK
	if (parentLink)	//used to have '&& focusElm != null' but focusElm not referenced anymore
	{
		//DCO TODO: test scenario that has parentLink but not recordid
		RZ.rte.isExistingLink = true;
		RZ.link[linkname].linkdisplaydefault = parentLink.innerHTML.replace(/<.*?>/gi,'');

		var r = parentLink.getAttribute("recordid");
		if ( r && r != "-1" )  // recordid is present
		{
			var m = parentLink.getAttribute("module");
			if (m == null) m = '';

			if ( !parentLink.getAttribute("template") )  //template link
			{
				linkType = 'template';
				id = 'recordid=' + r;
				module = 'module=' + m;
			}
			else    //url link
			{
				linkType = 'url';
				id = 'new';
				urlrecord = urlrecord + r;
				urlModule = urlModule + m;
				template = 'templatename='+parentLink.getAttribute("template");
				//hrefAttr = parentLink.href;
			}
		}
		else    // no recordid --> link manager url or file link
		{
			id = 'new';
			if (parentLink.href.indexOf('rz:link') != -1)   //file link
			{
				linkType = 'file'
				fileAttr = parentLink.getAttribute("file");
			}
			else                                            //url link
			{
				var href = parentLink.href;
				if (href.indexOf(location.href) == 0)
					href = href.substr(location.href.length)
				if (href.indexOf('#') == 0)     //link to anchor
				{
					linkType = 'createanchor';
					hrefAttr = escape(href);
				}
				else
				{
					linkType = 'url'
					hrefAttr = href;
				}
			}
		}
		// both values must be set DCO 06-06-2008
		RZ.link[linkname].linkfiledefault = fileAttr;
		RZ.link[linkname].linkurldefault = unescape(hrefAttr);
	}
	//----- NEW LINK
	else
	{
		RZ.rte.isExistingLink = false;
		id = 'new';
		linktosection = 0;

		if (inst.selection.getNode().tagName != 'IMG')
		{
			var txt = inst.selection.getContent({format : "text"});
			RZ.link[linkname].linkdisplaydefault = txt.replace(/<.*?>/gi,'');
		}
		//DCO 09-24-2014: below superceeds
		//else
		//	RZ.link[linkname].linkdisplaydefault = '...IMAGE...';
	}
	//DCO 09-23-2014: display text for LM: img tag or escaped html
	RZ.link[linkname].linkdisplay = (focusElm && focusElm.tagName && focusElm.tagName == 'IMG')
								  ? (focusElm.tagName
									 ? focusElm.outerHTML.replace(/\s*data-mce-.*?="[^"]*"/g, '') //"
								  	 : '...IMAGE...')
								  : RZ.link[linkname].linkdisplaydefault.replace(/<.*?>/gi,'');

	//DCO 09-23-2014: superceeded by above code
	// remove html from linkdisplay text
	//RZ.link[linkname].linkdisplay = RZ.link[linkname].linkdisplaydefault.replace(/<.*?>/gi,'');


	//----- Check for template create permission
	var templatesAllowed = RZpermits('links','c');
	if (templatesAllowed == false && linkType=='template')
	{
		alert('The link you have selected is a template link\n'
			+'(these links create new pages).\n\n'
			+'You do not have permission to create or update template links\n\n'
			+'You can either unlink and then relink to a file or url.\n'
			+'--OR--\n'
			+'Contact your web administrator for assistance.')
		return null;
	}
	//----- Setup and call the link manager.
	else
	{
		//----- The link manager properties are stored in the link object
		var linkurl = RZ.link[linkname].linkurl;

		if (RZ.isMSIE)
			linkurl = linkurl.replace(/_frame.html/,'_bridge.jsp');

		var url = linkurl + '&' + id + '&' + urlrecord + '&'
				+ template + '&linktype=' + linkType + linktemplate
				+ '&' + urlModule + '&href=' + hrefAttr + '&rte=tinymce';

		//		replace module attr for an existing link
		if (module != '')	//have module attr on an existing link
			url = url.replace(/module=[^\&]*\&/, module+'&');

		//		if no create permission to links module, disable template option
		if (templatesAllowed == false)
			url = url.replace(/template,/, '');

		//		disable seq option
		url = url.replace(/linkoptions=/, 'linkoptions=noseq,');

		//		append the set property
		RZ.set = RZ.link[linkname].set ? RZ.link[linkname].set : '';
		if (linktosectionid != '')	//false below means append but don't replace
			RZaddset(RZ.linkmodule + '.linktosectionid', linktosectionid, false);
		if (RZ.set != '')
			url = url + '&set=' + escape(RZ.set);

		var width  = RZ.link[linkname].linkwidth;
		var height = RZ.link[linkname].linkheight;

		var msg = '';
		for (var i in RZ.link[linkname])
			msg += i + '  =  ' + RZ.link[linkname][i] + '\n';
		msg += 'url: ' + url;

		RZtrace('Calling Link Manager linkname (' + RZ.link[linkname] + ') properties',msg);
        if (!RZ.isMSIE)
		{
			height -= 85;
			width -= 16;
		}
		url += (RZ.linkmanagertest ? '#test' : '');
		
		url = url.replace("/revize/util/linkmanager_frame.html","/revize/util/tiny_mce.5.1.2/linkmanager_frame.html");
		
		RZ.tinymce.modal.opener = inst;
		RZ.tinymce.modal.dialog = inst.windowManager.openUrl({
				title : 'Link Manager',
				url: url,
				inline : 0,
		});
		RZ.tinymce.modal.dialog.block("Loading");
		/*inst.windowManager.open({	//1st argument
									name   : RZ.tinymce.popupWindowName,
									file   : url,
									width  : width,
									height : height,
									inline : 0,
								},{	//2nd argument
									plugin_url : plugin_url
								});*/
	}
}

// TinyMCE 5 Listen for messages
window.addEventListener('message', function (event) {
  console.log("Recieved: ",event);
  var _d = event.data;
  if (_d.indexOf("eventType") != -1) { _d = JSON.parse(_d); }
  if (_d.hasOwnProperty("eventType")) {
	  if (_d.eventType == "ready") {
			if (event.source.name == "mainFrame") {
				RZ.tinymce.modal.dialog.unblock();
				//RZ.tinymce.modal.frame = event.source.parent; // 2/21/2020 - Loses reference and goes null when function ends. :(
				event.source.parent.postMessage(JSON.stringify({ eventType : "readyPong", val : RZ.tinymce.modal.opener.id }));
			}
	  }
  }
});