/**
 * @author Revize, LLC.
 * @copyright Copyright (c) 2008, Revize, LLC, All rights reserved.
 *
 * Slightly modified version of advlink plugin
 * (still uses advlink language pack)
 *
 * executeCommand: mceAdvLink case changed to interface to Revize link manager
 *
 * add jsp parameter of 'advlink' to call the tinyMCE instead of link manager
 *
 * Version 3.0.1, migrated and modified by Nicholas J. Michalek
 */

/* Import plugin specific language pack */

tinyMCE.PluginManager.add('revize_link_manager', function(editor, url) {
  var openDialog = function () {
	var parentLink = editor.dom.getParent(editor.selection.getNode(),'A');
	
	//if (editor.selection.isCollapsed() && !parentLink) { return false; } // Disable Button if nothing selected.
    RZtinymceToLinkManager(editor, parentLink, "");
  };

  // Add a button that opens a window
  editor.ui.registry.addButton('revize_link', {
    icon: 'link',
    onAction: function () {
      // Open window
	  editor.targetElm.linktemplate = "";
	  editor.editorId = editor.targetElm.id;
      openDialog();
    },
	onSetup: function (api) {
		/*editor.on("nodechange", function(el) { // Disable Button if nothing selected.
			api.setDisabled(el.element.nodeName != 'A' && el.element.name);
		});*/
	}
  });

  // Adds a menu item, which can then be included in any menu via the menu/menubar configuration
  editor.ui.registry.addMenuItem('exampleb', {
    text: 'Example plugin',
    onAction: function() {
      // Open window
      openDialog();
    }
  });

  return {
    getMetadata: function () {
      return  {
		longname:'Revize Link Manager',
		author:'Revize LLC (Dave Otto, Nicholas J. Michalek)',
		authorurl:'http://www.revize.com/',
		infourl:'http://www.revize.com/',
		version:"3.2.5.188b"
      };
    }
  };
});
